﻿'Option Strict On

Imports System
Imports System.Data
Imports System.Net
Imports System.Text
Imports System.Text.RegularExpressions
Imports System.Security
Imports System.IO
Imports System.Diagnostics
Imports System.Diagnostics.Process
Imports System.ComponentModel
Imports System.Threading
Imports Microsoft.Win32
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports Microsoft.VisualBasic
Imports System.Data.SqlClient

Partial Class _Default
    Inherits System.Web.UI.Page
    Public HttpGetNames(), HttpGetData(), arrReturnedVals() As String
    Public strSearchString As String
    Public HttpGetAll As NameValueCollection

    Private elapsedTime As Integer
    Private eventHandled As Boolean
    Public bolAddWildCard As Boolean = True
    Public Event Exited As EventHandler
    Public regStores, regQueues, regPID, regMax_Results As Object
    Public arrStores(6, 1) As String
    Public arrResults(13, 1) As String
    Public qr As New DataTable()

    Protected Sub Page_LoadComplete(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LoadComplete
        If (Not IsPostBack) Then
            If (Session("ErrorMessages2") <> "") Then
                After_Move()
            Else
                Main()
            End If
        End If
    End Sub

    Sub submit(ByVal sender As Object, ByVal e As EventArgs)
        Dim daDayToday As Date = Now
        Dim daDayYesterday As Date = Now
        Dim daDayDayBefore As Date = Now
        Dim strDateRange As String
        Dim intError, intFileNum As Integer

        bolAddWildCard = False
        daDayYesterday = daDayYesterday.AddDays(-1)
        daDayDayBefore = daDayDayBefore.AddDays(-2)

        'Response.Write("session pname = " & Session("pname") & "<br />" & "pn.text = " & pn.Text & "<br />")
        Session("pname") = pn.Text
        Session("pid") = pid.Text
        Session("pdesc") = desc.Text
        session("paccn") = accn.Text
        session("pmod") = [mod].SelectedValue
        Session("SortType") = Nothing
        Session("SortCol") = Nothing
        Archive_Action.Text = Nothing

        Get_Hostname()
        ReadRegistry()
        AddFormItems()
        intError = Clean_Input()
        Session("Archive") = Trim(Archives.Text)
        RePopulateSessionVars()
        PopulateInputFields(intError)
        intFileNum = FindFileNum()
        If (intError = 0) Then
            QueryResults.Visible = True
            'Response.Write("Using file num: " & Session("FileNum") & " and strSearchString = " & strSearchString & "<br />")
            If (ddate.SelectedItem.Value = "Today") Then
                Session("HaveDate") = 1
                FireQuery(intFileNum, Format(daDayToday.Date, "yyyyMMdd"))
            ElseIf (ddate.SelectedItem.Value = "Yesterday") Then
                Session("HaveDate") = 1
                FireQuery(intFileNum, Format(daDayYesterday.Date, "yyyyMMdd"))
            ElseIf (ddate.SelectedItem.Value = "3") Then
                strDateRange = Format(daDayDayBefore.Date, "yyyyMMdd") & "-" & Format(daDayToday.Date, "yyyyMMdd")
                Session("HaveDate") = 1
                FireQuery(intFileNum, strDateRange)
            ElseIf (ddate_text.Text = "*") Then
                strDateRange = Format(daDayToday.AddDays(-364), "yyyyMMdd") & "-" & Format(daDayToday.Date, "yyyyMMdd")
                Session("HaveDate") = 0
                FireQuery(intFileNum, strDateRange)
            ElseIf (ddate_text.Text <> "") Then
                Session("HaveDate") = 1
                FireQuery(intFileNum, ddate_text.Text)
            Else
                strDateRange = Format(daDayToday.AddDays(-364), "yyyyMMdd") & "-" & Format(daDayToday.Date, "yyyyMMdd")
                Session("HaveDate") = 0
                FireQuery(intFileNum, strDateRange)
            End If
            ReadResponses(intFileNum)
            'Filter_Responses()
            Write_Responses()
        Else
            QueryResults.Visible = False
        End If
        ErrorMessages.Text = "<div id=""message"">" & Session("perrormessage") & Session("ErrorMessages") & "</div>" & Session("ErrorMessages2")
        Session("ErrorMessages2") = ""
        Session("ErrorMessages") = ""
        Session("perrormessage") = Nothing
        Session("HaveResults") = Nothing
    End Sub
    Sub Run_Reset(ByVal sender As Object, ByVal e As EventArgs)

        'Response.Redirect(Session("URL"))

        Session("pname") = Session("opname")
        Session("pid") = Session("opid")
        Session("paccn") = Session("opaccn")
        Session("pmod") = "US"
        Session("date") = ""
        Session("desc") = ""
        Session("psub") = Session("opsub")

        pn.Text = Session("pname")
        pid.Text = Session("pid")
        Archives.Text = Session("OArchive")
        accn.Text = Nothing
        desc.Text = Nothing
        ddate_text.Text = Nothing
        Archive_Action.Text = Nothing
        ddate.SelectedValue = "na"
        [mod].SelectedValue = "US"
        QueryResults.Visible = False
        ErrorMessages.Text = "<div id=""message"">" & Session("perrormessage") & Session("ErrorMessages") & "</div>" & Session("ErrorMessages2")
        Session("ErrorMessages2") = ""
        Session("ErrorMessages") = ""
        Session("perrormessage") = Nothing
        Session("HaveResults") = Nothing
    End Sub
    Sub Run_Clear(ByVal sender As Object, ByVal e As EventArgs)
        pn.Text = Nothing
        pid.Text = Nothing
        accn.Text = Nothing
        desc.Text = Nothing
        ddate_text.Text = Nothing
        Archive_Action.Text = Nothing
        Archives.Text = Session("OArchive")
        [mod].SelectedValue = "US"
        QueryResults.Visible = False
        ddate.SelectedValue = "na"
        ErrorMessages.Text = "<div id=""message"">" & Session("perrormessage") & Session("ErrorMessages") & "</div>" & Session("ErrorMessages2")
        Session("ErrorMessages2") = ""
        Session("ErrorMessages") = ""
        Session("perrormessage") = Nothing
        Session("HaveResults") = Nothing
    End Sub

    Sub After_Move()
        'Will come here after a movescu has been started
        Dim stopwatch As Stopwatch = stopwatch.StartNew
        Thread.Sleep(1000)
        stopwatch.Stop()
        Get_Hostname()
        ReadRegistry()
        AddFormItems()
        PopulateInputFields(0)
        ReadResponses(Session("FileNum"))
        'Filter_Responses()
        Write_Responses()
        ErrorMessages.Text = "<div id=""message"">" & Session("perrormessage") & Session("ErrorMessages") & "</div>" & Session("ErrorMessages2")
        Session("ErrorMessages") = Nothing
        Session("ErrorMessages2") = Nothing
        Session("perrormessage") = Nothing
        Session("HaveResults") = Nothing
    End Sub
    Sub Main()
        'Will come here when launched and on client window refresh
        Dim intError, intFileNum As Integer
        Dim strOPName, strOPId, strOPAccn, strDateRange As String
        Dim daDayToday As Date = Now

        mBody.Attributes.Add("onload", "window.resizeTo(900,800);")
        Get_Hostname()
        ReadRegistry()
        strOPName = Session("opname")
        strOPId = Session("opid")
        strOPAccn = Session("opaccn")
        Session.Clear()
        Session("opname") = strOPName
        Session("opid") = strOPId
        Session("opaccn") = strOPAccn
        Get_Hostname()
        ReadRegistry()
        AddFormItems()
        PopulaeSessionVars()
        Session("regWC") = "no"
        intError = Clean_Input()
        PopulateInputFields(intError)
        If (intError = 0) Then
            'Response.Write("Going to fire the query")
            bolAddWildCard = True
            intFileNum = FindFileNum()
            strDateRange = Format(daDayToday.AddDays(-1094), "yyyyMMdd") & "-" & Format(daDayToday.Date, "yyyyMMdd")
            FireQuery(intFileNum, strDateRange)
            ReadResponses(intFileNum)
            'Filter_Responses()
            Write_Responses()
            ErrorMessages.Text = "<div id=""message"">" & Session("perrormessage") & Session("ErrorMessages") & "</div>" & Session("ErrorMessages2")
            Session("ErrorMessages") = ""
            Session("ErrorMessages2") = ""
            Session("HaveResults") = Nothing
        End If
    End Sub

    Sub QR_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        'This is not a postback event because response.redirect is used.
        Dim daDayToday As Date = Now
        Dim intLC, intLC2, intDone, intFileNum As Integer
        Dim strDate, strArgs, strMoveResultsFile, strArchiveIP, strArchivePort, strArchiveAET, strMoveCheckFile As String
        Dim strCurLine, strTempHost As String
        Dim row As GridViewRow = QueryResults.SelectedRow
        Dim objStreamReader As StreamReader

        Get_Hostname()
        ReadRegistry()
        strDate = Format(daDayToday.Date, "yyyyMMdd")
        Dim p As Process
        For Each p In Process.GetProcesses
            If (InStr(p.ProcessName, "movescu") > 0) Then
                intLC += 1
            End If
        Next

        'Response.Write("You selected " & row.Cells(1).Text & " | " & row.Cells(2).Text & " | " & row.Cells(3).Text & " | " & row.Cells(4).Text & " | " & row.Cells(5).Text & " | " & row.Cells(6).Text & " | " & row.Cells(7).Text & " | " & row.Cells(8).Text & " | " & row.Cells(9).Text & " | " & row.Cells(10).Text & " | " & row.Cells(11).Text & " | " & row.Cells(12).Text & "<br />")
        If (intLC < Session("regQueues")) Then
            intLC2 = 0
            intDone = 0
            While (intLC2 < 10000 And intDone <> 1)
                strSearchString = "\inetpub\wwwroot\Workplace_DICOM_QR_tool\logs\" & strDate & "_" & Session("FileNum") & "_" & intLC2 & "_" & "move_check.txt"
                If (System.IO.File.Exists(strSearchString)) Then
                    intLC2 = intLC2 + 1
                Else
                    intFileNum = intLC2
                    intDone = 1
                End If
            End While
            If (intLC2 >= 10000) Then
                'Need to find a way to give a meaningfull error message here
                Return
            End If

            strMoveCheckFile = "\inetpub\wwwroot\Workplace_DICOM_QR_tool\logs\" & strDate & "_" & Session("FileNum") & "_" & intFileNum & "_" & "move_check.txt"
            Dim RunningMoves As New Process()
            RunningMoves.StartInfo.FileName = "cmd.exe"
            RunningMoves.StartInfo.Arguments = "/c wmic PROCESS get Caption,Commandline,Processid > " & strMoveCheckFile
            RunningMoves.StartInfo.CreateNoWindow = True
            RunningMoves.Start()
            RunningMoves.WaitForExit()
            RunningMoves.Close()

            Dim stopwatch As Stopwatch = stopwatch.StartNew
            Thread.Sleep(500)
            stopwatch.Stop()

            objStreamReader = File.OpenText(strMoveCheckFile)
            While (Not objStreamReader.EndOfStream)
                strCurLine = objStreamReader.ReadLine
                If (InStr(strCurLine, row.Cells(11).Text)) Then
                    Session("ErrorMessages2") = Session("ErrorMessages2") & "<div id=""message"">" & "This study is already in the queue.</div>"
                    Response.Redirect("Default.aspx")
                End If
            End While

            strMoveResultsFile = "\inetpub\wwwroot\Workplace_DICOM_QR_tool\logs\" & strDate & "_" & Session("FileNum") & "_" & intFileNum & "_" & "move_results.txt"

            'Need to resolve the archive name to the array element number
            intDone = 0
            For i As Integer = 0 To UBound(arrStores, 2)
                'Response.Write("row.Cells(12).text = " & row.Cells(12).Text & " | arrStores(1, " & i & ") = " & arrStores(1, i) & "<br />")
                If row.Cells(12).Text = arrStores(0, i) Then
                    strArchiveIP = arrStores(1, i)
                    strArchivePort = arrStores(2, i)
                    strArchiveAET = arrStores(3, i)
                    'strArgs = "-v -d -aet VMWARE01 -aec 001S76OT06DPQ2 -aem MCSTGWV -k 0008,0052=STUDY -k 0020,000D=" & row.Cells(11).Text & " -S -xe mcpds 40090 > " & strMoveResultsFile
                    If (Not Session("regMV") = Nothing And Session("regPID") = "CCF") Then
                        strTempHost = Session("regMV")
                    Else
                        strTempHost = Session("HostName")
                    End If
                    'strArgs = "-v -d -aet " & Session("HostName") & " -aec " & strArchiveAET & " -aem " & strTempHost & " -k 0008,0052=STUDY -k 0020,000D=" & row.Cells(11).Text & " -S -xe " & strArchiveIP & " " & strArchivePort & " > " & strMoveResultsFile
                    strArgs = "-v -d -aet " & Session("HostName") & " -aec " & strArchiveAET & " -aem " & strTempHost & " -k 0008,0052=SERIES -k 0020,000D=" & row.Cells(11).Text & " -k 0020,000E=1.2.840.113619.2.98.11207.1454665765.0.6 -S -xe " & strArchiveIP & " " & strArchivePort & " > " & strMoveResultsFile
                    'Response.Write("Args = " & strArgs & "<br />")
                    Dim DICOMMove As New Process()
                    Try
                        DICOMMove.StartInfo.FileName = "cmd.exe"
                        DICOMMove.StartInfo.Arguments = "/c \inetpub\wwwroot\Workplace_DICOM_QR_tool\movescu.exe " & strArgs
                        DICOMMove.StartInfo.CreateNoWindow = True
                        DICOMMove.Start()
                        'DICOMMove.WaitForExit()
                        'Session("ErrorMessages2") = Session("ErrorMessages2") & "Study for " & row.Cells(0).Text & " " & row.Cells(1).Text & " " & row.Cells(2).Text & " has been sent.<br />"
                        'Session("ErrorMessages2") = Session("ErrorMessages2") & "There are " & intLC & " queries running"
                        Session("ErrorMessages2") = Session("ErrorMessages2") & "!!!RETRIEVE STARTED!!!  PLEASE CHOOSE ANOTHER STUDY TO RETRIEVE OR CLOSE THE BROWSER<br />"
                        Stopwatch.StartNew()
                        Thread.Sleep(1500)
                        stopwatch.Stop()
                        Response.Redirect("Default.aspx")
                    Catch ex As Exception
                        Response.Write("Error: " & ex.Message)
                    End Try
                End If
            Next
        Else
            ErrorMessages.Text = "There are " & intLC & " queries currently running which is at or over the maximum of " & regQueues & ".  Please try again later<br />"
        End If
    End Sub
    Sub QR_PageIndexChanging(ByVal sender As Object, ByVal e As GridViewPageEventArgs)
        Get_Hostname()
        ReadRegistry()
        ReadResponses(Session("FileNum"))
        'Filter_Responses()
        If (Session("SortOrder") = "ASC" Or Session("SortOrder") = "DESC") Then
            SortArray(Session("SortCol"), Session("SortOrder"), Session("SortType"))
        End If
        mBody.Attributes.Add("onload", "")
        Write_Responses()
        QueryResults.DataSource = qr
        QueryResults.PageIndex = e.NewPageIndex
        QueryResults.DataBind()
        Session("ErrorMessages") = ""
        Session("ErrorMessages2") = ""
        Session("HaveResults") = Nothing
    End Sub
    Sub QR_SortChanging(ByVal sender As Object, ByVal e As GridViewSortEventArgs)
        Dim strOrder, strType As String

        Get_Hostname()
        ReadRegistry()
        ReadResponses(Session("FileNum"), True)
        'Filter_Responses()
        'Response.Write("sortexpression = " & e.SortExpression & "<br />")
        If (Session("SortOrder") = "ASC" And Session("SortField") = e.SortExpression) Then
            strOrder = "DESC"
            Session("SortOrder") = "DESC"
        ElseIf (Session("SortOrder") = "DESC" And Session("SortField") = e.SortExpression) Then
            strOrder = "ASC"
            Session("SortOrder") = "ASC"
        Else
            strOrder = "ASC"
            Session("SortOrder") = "ASC"
            Session("SortField") = e.SortExpression
        End If
        'Response.Write("sort order = " & strOrder & " sort column = " & e.SortExpression & "<br />")
        If (e.SortExpression = "0") Then
            strType = "str"
        ElseIf (e.SortExpression = "1") Then
            strType = "str"
        ElseIf (e.SortExpression = "2") Then
            strType = "int"
        ElseIf (e.SortExpression = "3") Then
            strType = "str"
        ElseIf (e.SortExpression = "4") Then
            strType = "int"
        Else
            strType = "str"
        End If
        Session("SortType") = strType
        Session("SortCol") = e.SortExpression
        SortArray(e.SortExpression, strOrder, strType)
        Write_Responses()
    End Sub

    Function Clean_Input() As Integer
        Dim exp As New Regex("\*", RegexOptions.IgnoreCase)
        Dim intOccurances, intOcc2, intFirstOcc, intSecondOcc, intYear, intMonth, intDay As Integer
        Dim bolPIDiswildcard, bolDatewildcard As Boolean

        Session("perrormessage") = ""

        If (Not Session("regWC") = "yes") Then
            If Session("pname") = "" Or Session("pname") = "*" Then
                If Trim(Session("pid")) = "" Or Session("pid") = "*" Then
                    Session("perrormessage") = Session("perrormessage") & "Both patient name and patient ID can not be blank<br />"
                    Return 1
                End If
            End If
        End If

        'date has to be in the format of yyyymmdd or *.
        If (ddate.SelectedValue = "na") Then
            Session("pdate") = ddate_text.Text
            If (Trim(Session("pdate") <> "")) Then
                If (Session("pdate") <> "*" And Len(Session("pdate")) = 8 And IsNumeric(Session("pdate"))) Then
                    intYear = Convert.ToInt16(Left(Session("pdate"), 4))
                    intMonth = Convert.ToInt16(Mid(Session("pdate"), 5, 2))
                    intDay = Convert.ToInt16(Right(Session("pdate"), 2))
                    If (intYear < 1900 Or intYear > 2210) Then
                        Session("perrormessage") = Session("perrormessage") & "Year must be between 1900 and 2210.  Please use YYYYMMDD<br />"
                        Return 1
                    End If
                    If (intMonth < 1 Or intMonth > 12) Then
                        Session("perrormessage") = Session("perrormessage") & "Date is not the correct format.  Please use YYYYMMDD<br />"
                        Return 1
                    End If
                    If (intDay < 1 Or intDay > 31) Then
                        Session("perrormessage") = Session("perrormessage") & "Date is not the correct format.  Please use YYYYMMDD<br />"
                        Return 1
                    End If
                ElseIf (Trim(Session("pdate")) <> "*") Then
                    Session("perrormessage") = Session("perrormessage") & "Date is not in the correct format.<br />"
                    Return 1
                End If
            End If
        ElseIf (ddate.SelectedValue = "*") Then
            Session("pdate") = "*"
            ddate_text.Text = "*"
        End If

        intOccurances = 0
        'Count the number of field seperators in the pname input
        If (Not Session("pname") = vbNullString) Then
            intOccurances = exp.Matches(Session("pname")).Count
        End If

        intOcc2 = 0
        'Count the number of wildcards in the pid input
        If (Not Session("pid") = vbNullString) Then
            intOcc2 = exp.Matches(Session("pid")).Count
        End If

        If (Session("pname") <> "") Then
            If (Session("regPID") = "CCF") Then
                'Replace field seperators (^) with wildcards (*)
                Session("pname") = Replace(Session("pname"), "^ ", "*")
                Session("pname") = Replace(Session("pname"), "^", "*")
                'Might be (,) instead of (^) as a field seperator
                Session("pname") = Replace(Session("pname"), ", ", "*")
                Session("pname") = Replace(Session("pname"), ",", "*")
                Session("pname") = Replace(Session("pname"), " ", "*")

                'Check if we have more than one field seperator in pname
                intOccurances = exp.Matches(Session("pname")).Count
                intOcc2 = exp.Matches(Session("pid")).Count

                If (intOccurances > 1) Then
                    'Find the first field seperator *
                    intFirstOcc = InStr(Session("pname"), "*")
                    'Need to find the 2nd field seperator.  There could be more than 2 and we need to get rid of everything from the 2nd on
                    intSecondOcc = InStr(intFirstOcc + 1, Session("pname"), "*")
                    Session("pname") = Left(Session("pname"), intSecondOcc - 1)
                End If
                If (bolAddWildCard = True) Then
                    'If pname does not end with an *, add one
                    If (Right(Session("pname"), 1) <> "*") Then
                        Session("pname") = Session("pname") + "*"
                    End If
                End If
            End If

            'Convert the patient name case
            If (Session("regNF") = "upper") Then
                Session("pname") = UCase(Session("pname"))
            ElseIf (Session("regNF") = "lower") Then
                Session("pname") = LCase(Session("pname"))
            End If

            'Check if we have more than one field seperator in pname
            intOccurances = exp.Matches(Session("pname")).Count
            intOcc2 = exp.Matches(Session("pid")).Count

            'Minimum length of name is 3 characters
            If (Not Session("regWC") = "yes") Then
                If (intOcc2 = Len(Session("pid"))) Then
                    bolPIDiswildcard = True
                Else
                    bolPIDiswildcard = False
                End If
                If (ddate_text.Text = Nothing Or ddate_text.Text = "*") Then
                    If (ddate.SelectedValue = "na" Or ddate.SelectedValue = "*") Then
                        bolDatewildcard = True
                    End If
                Else
                    bolDatewildcard = False
                End If
                If (Len(Session("pname")) < intOccurances + 3) Then
                    If (Session("pid") = "*" Or Session("pid") = Nothing) Then
                        If (ddate_text.Text = Nothing Or ddate_text.Text = "*") Then
                            If (ddate.SelectedValue = "na" Or ddate.SelectedValue = "*") Then
                                Session("perrormessage") = Session("perrormessage") & "Patient name must be 3 characters long (not including *)<br />"
                                Return 1
                            End If
                        End If
                    End If
                End If
                'If (Len(Session("pname")) < intOccurances + 3 And Session("pid") = Nothing And bolDatewildcard = True And ddate.SelectedValue = "na") Then
                'Session("perrormessage") = Session("perrormessage") & "Patient name must be 3 characters long (not including *)<br />"
                'Return 1
                'ElseIf (Len(Session("pname")) < intOccurances + 3 And bolPIDiswildcard = True And bolDatewildcard = True And ddate.SelectedValue = "na") Then
                'Session("perrormessage") = Session("perrormessage") & "Patient name must be 3 characters long (not including *)<br />"
                'Return 1
                'End If
            End If

            pn.Text = Session("pname")
        End If

        If (Session("regPID") = "CCF") Then
            If (Len(Session("pid")) = 8) Then
                Session("pid") = "000" + Session("pid")
            End If
            pid.Text = Session("pid")
        End If

        'The description field must start and end with *.  Need to add them if they are not there.
        If (Session("pdesc") <> "*" And Len(Session("pdesc")) = 0) Then
            Session("pdesc") = "*"
        End If
        If (Len(Session("pdesc")) > 1 And Left(Session("pdesc"), 1) <> "*") Then
            Session("pdesc") = "*" + Session("pdesc")
        End If
        If (Len(Session("pdesc")) > 1 And Right(Session("pdesc"), 1) <> "*") Then
            Session("pdesc") = Session("pdesc") + "*"
        End If

        If (arrStores(0, 0) = "") Then
            Session("perrormessage") = Session("perrormessage") & "Error in PACS archive definition!<br />"
            Return 1
        End If

        If (Session("db_name") = "") Then
            Session("perrormessage") = Session("perrormessage") & "Local database user not defined!<br />"
            Return 1
        End If
        Return 0
    End Function
    Function FindFileNum() As Integer
        Dim daDayToday As Date = Now
        Dim intLC, intDone, intFileNum As Integer
        Dim strdate As String

        strdate = Format(daDayToday.Date, "yyyyMMdd")
        intLC = 0
        intDone = 0
        While (intLC < 10000 And intDone <> 1)
            strSearchString = "\inetpub\wwwroot\Workplace_DICOM_QR_tool\logs\" & strdate & "_" & intLC & "_" & "query_text.txt"
            If (System.IO.File.Exists(strSearchString)) Then
                intLC = intLC + 1
            Else
                'Response.Write("Using file number " & intLC & "<br />")
                intFileNum = intLC
                intDone = 1
            End If
        End While
        If (intLC >= 10000) Then
            'Need to find a way to give a meaningfull error message here
            Return -1
        End If
        Session("FileNum") = intLC
        Return intLC
    End Function
    Sub FireQuery(ByVal intFileNum As Integer, Optional ByVal daDate As String = "*", Optional ByVal intRun As Integer = 1)

        Dim daDayToday As Date = Now
        Dim strDate, strWriteString, strDICOMFile, strResultsFile, strArgs As String
        Dim intDone, intLC, intLC2 As Integer
        Dim exp As New Regex("\*", RegexOptions.IgnoreCase)

        elapsedTime = 0
        eventHandled = False
        strDate = Format(daDayToday.Date, "yyyyMMdd")
        If (Not daDate = "*") Then
            strWriteString = "(0008,0020) DA [" & daDate & "]" & vbCrLf
        Else
            strWriteString = "(0008,0020) DA []" & vbCrLf
        End If
        strWriteString = strWriteString & "(0008,0030) TM []" & vbCrLf
        strWriteString = strWriteString & "(0008,0052) CS [STUDY]" & vbCrLf
        If (Not Session("paccn") = "*") Then
            strWriteString = strWriteString & "(0008,0050) SH [" & Session("paccn") & "]" & vbCrLf
        Else
            strWriteString = strWriteString & "(0008,0050) SH []" & vbCrLf
        End If
        If (Not Session("pmod") = "US") Then
            strWriteString = strWriteString & "(0008,0061) CS [US]" & vbCrLf
        Else
            strWriteString = strWriteString & "(0008,0061) CS [US]" & vbCrLf
        End If
        If (Not Session("pdesc") = "*") Then
            strWriteString = strWriteString & "(0008,1030) LO [" & Session("pdesc") & "]" & vbCrLf
        Else
            strWriteString = strWriteString & "(0008,1030) LO []" & vbCrLf
        End If
        If (Not Session("pname") = "*") Then
            strWriteString = strWriteString & "(0010,0010) PN [" & Session("pname") & "]" & vbCrLf
        Else
            strWriteString = strWriteString & "(0010,0010) PN []" & vbCrLf
        End If
        If (Not Session("pid") = "*") Then
            strWriteString = strWriteString & "(0010,0020) LO [" & Session("pid") & "]" & vbCrLf
        Else
            strWriteString = strWriteString & "(0010,0020) LO []" & vbCrLf
        End If
        strWriteString = strWriteString & "(0010,0030) DA []" & vbCrLf
        strWriteString = strWriteString & "(0020,000D) UI []" & vbCrLf
        strWriteString = strWriteString & "(0020,1206) IS []" & vbCrLf
        strWriteString = strWriteString & "(0020,1208) IS []" & vbCrLf

        Dim objWriter As New System.IO.StreamWriter(strSearchString)
        objWriter.Write(strWriteString)
        objWriter.Close()

        Dim stopwatch As Stopwatch = stopwatch.StartNew
        Thread.Sleep(500)
        stopwatch.Stop()

        Session("SortOrder") = ""
        'Response.Write("0 = " & arrStores(0, 0) & " 1 = " & arrStores(0, 1) & "<br />")
        strDICOMFile = "\inetpub\wwwroot\Workplace_DICOM_QR_tool\logs\" & strDate & "_" & intFileNum & "_" & "query_dicom.dcm"
        'Convert the text DICOM information into a DICOM file
        Process.Start("\inetpub\wwwroot\Workplace_DICOM_QR_tool\dump2dcm.exe", strSearchString & " " & strDICOMFile)
        stopwatch.Start()
        Thread.Sleep(500)
        stopwatch.Stop()

        If (Not Archives.SelectedValue = "All") Then
            Archive_Action.Text = Archives.SelectedValue & " queried."
        ElseIf (Not Session("Archive") = "All") Then
            Archive_Action.Text = Session("Archive") & " queried."
        Else
            Archive_Action.Text = "Archives queried."
        End If
        'Loop through each image store
        For intLC2 = 0 To UBound(arrStores, 2) - 1
            If ((UBound(arrStores, 2) - 1) > -1) Then
                If (Session("Archive") = "All" Or Session("Archive") = arrStores(0, intLC2)) Then
                    strResultsFile = "\inetpub\wwwroot\Workplace_DICOM_QR_tool\logs\" & strDate & "_" & intFileNum & "_" & arrStores(0, intLC2) & "_" & "query_results_" & intRun & ".txt"

                    'Fire the query
                    'strArgs = "-v -aet " & Session("HostName") & " -aec " & arrStores(3, intLC2) & " -S " & arrStores(1, intLC2) & " " & arrStores(2, intLC2) & " " & strDICOMFile & " > " & Chr(34) & strResultsFile & Chr(34)
                    
                    strArgs = "-v -aet " & Session("HostName") & " --cancel " & Session("regMax_Results") + 1 & " -aec " & arrStores(3, intLC2) & " -S " & arrStores(1, intLC2) & " " & arrStores(2, intLC2) & " " & strDICOMFile & " > " & Chr(34) & strResultsFile & Chr(34)

                    'Response.Write("args = " & strArgs & "<br />")
                    'Process.Start("cmd.exe", "/c \inetpub\wwwroot\Workplace_DICOM_QR_tool\findscu.exe " & strArgs)
                    Dim DICOMQuery As New Process()
                    Try
                        DICOMQuery.StartInfo.FileName = "cmd.exe"
                        DICOMQuery.StartInfo.Arguments = "/c \inetpub\wwwroot\Workplace_DICOM_QR_tool\findscu.exe " & strArgs
                        DICOMQuery.StartInfo.CreateNoWindow = True
                        DICOMQuery.Start()
                        DICOMQuery.WaitForExit()
                    Catch ex As Exception
                        Response.Write("Error: " & ex.Message)
                    End Try
                End If
            End If
            stopwatch.Start()
            Thread.Sleep(500)
            stopwatch.Stop()
        Next intLC2
    End Sub
    Sub ReadResponses(ByVal intFileNum As Integer, Optional ByVal intIsSorting As Integer = False)
        Dim daDayToday As Date = Now
        Dim strDate, strResultsFile, strCurLine, strErrorComment, strErrorComment2 As String
        Dim intStart, intEnd, intLC, intLC2, intLC3, intSuccess, intPos1 As Integer
        Dim intStatusFound As Integer = 0, intError As Integer = 0, intResults As Integer = 0, intFirstSep As Integer = 0

        strDate = Format(daDayToday.Date, "yyyyMMdd")
        intLC = 0
        'Response.Write("ubound(arrStores, 2) - 1 = " & UBound(arrStores, 2) - 1 & "<br />")
        For intLC2 = 0 To UBound(arrStores, 2) - 1
            For intLC3 = 1 To 3
                strResultsFile = "\inetpub\wwwroot\Workplace_DICOM_QR_tool\logs\" & strDate & "_" & intFileNum & "_" & arrStores(0, intLC2) & "_" & "query_results_" & intLC3 & ".txt"

                If (System.IO.File.Exists(strResultsFile)) Then
                    Dim objStreamReader As StreamReader
                    objStreamReader = File.OpenText(strResultsFile)
                    strErrorComment = ""
                    intFirstSep = 0
                    While (Not objStreamReader.EndOfStream)
                        strCurLine = objStreamReader.ReadLine
                        If (intFirstSep = 0) Then
                            If (InStr(strCurLine, "--------")) Then
                                intFirstSep += 1
                            ElseIf (InStr(strCurLine, "0006:0317")) Then
                                'Status message
                                intStatusFound += 1
                                intStart = InStr(strCurLine, " ")
                                If (Not intStart = 0) Then
                                    Session("ErrorMessages") = Session("ErrorMessages") & "PACS Archive " & arrStores(0, intLC2) & " had an error of " & Right(strCurLine, Len(strCurLine) - intStart) & "<br />"
                                    intError = 1
                                End If
                            End If
                        Else
                            If (InStr(strCurLine, "(0010,0020)")) Then
                                'PatientID
                                intStart = InStr(strCurLine, "[")
                                If (Not intStart = 0) Then
                                    intEnd = InStr(strCurLine, "]")
                                    arrResults(0, intLC) = Mid(strCurLine, intStart + 1, intEnd - intStart - 1)
                                End If
                            ElseIf (InStr(strCurLine, "(0010,0010)")) Then
                                'PatientsName
                                intStart = InStr(strCurLine, "[")
                                If (Not intStart = 0) Then
                                    intEnd = InStr(strCurLine, "]")
                                    arrResults(1, intLC) = Mid(strCurLine, intStart + 1, intEnd - intStart - 1)
                                End If
                            ElseIf (InStr(strCurLine, "(0010,0030)")) Then
                                'PatientsBirthDate
                                intStart = InStr(strCurLine, "[")
                                If (Not intStart = 0) Then
                                    intEnd = InStr(strCurLine, "]")
                                    arrResults(2, intLC) = Mid(strCurLine, intStart + 1, intEnd - intStart - 1)
                                End If
                            ElseIf (InStr(strCurLine, "(0008,0050)")) Then
                                'AccessionNumber
                                intStart = InStr(strCurLine, "[")
                                If (Not intStart = 0) Then
                                    intEnd = InStr(strCurLine, "]")
                                    arrResults(3, intLC) = Mid(strCurLine, intStart + 1, intEnd - intStart - 1)
                                End If
                            ElseIf (InStr(strCurLine, "(0008,0020)")) Then
                                'StudyDate
                                intStart = InStr(strCurLine, "[")
                                If (Not intStart = 0) Then
                                    intEnd = InStr(strCurLine, "]")
                                    arrResults(4, intLC) = Mid(strCurLine, intStart + 1, intEnd - intStart - 1)
                                End If
                            ElseIf (InStr(strCurLine, "(0008,0030)")) Then
                                'StudyTime
                                intStart = InStr(strCurLine, "[")
                                If (Not intStart = 0) Then
                                    intEnd = InStr(strCurLine, "]")
                                    arrResults(5, intLC) = Mid(strCurLine, intStart + 1, intEnd - intStart - 1)
                                    If (InStr(arrResults(5, intLC), ".")) Then
                                        intPos1 = InStr(arrResults(5, intLC), ".")
                                        arrResults(5, intLC) = Left(arrResults(5, intLC), intPos1 - 1)
                                    End If
                                End If
                            ElseIf (InStr(strCurLine, "(0008,0061)")) Then
                                'ModalitiesInStudy
                                intStart = InStr(strCurLine, "[")
                                If (Not intStart = 0) Then
                                    intEnd = InStr(strCurLine, "]")
                                    arrResults(6, intLC) = Mid(strCurLine, intStart + 1, intEnd - intStart - 1)
                                End If
                            ElseIf (InStr(strCurLine, "(0008,1030)")) Then
                                'StudyDescription
                                intStart = InStr(strCurLine, "[")
                                If (Not intStart = 0) Then
                                    intEnd = InStr(strCurLine, "]")
                                    arrResults(7, intLC) = Mid(strCurLine, intStart + 1, intEnd - intStart - 1)
                                End If
                            ElseIf (InStr(strCurLine, "(0020,1206)")) Then
                                '
                                intStart = InStr(strCurLine, "[")
                                If (Not intStart = 0) Then
                                    intEnd = InStr(strCurLine, "]")
                                    arrResults(8, intLC) = Mid(strCurLine, intStart + 1, intEnd - intStart - 1)
                                End If
                            ElseIf (InStr(strCurLine, "(0020,1208)")) Then
                                'NumberOfStudyRelatedInstances
                                intStart = InStr(strCurLine, "[")
                                If (Not intStart = 0) Then
                                    intEnd = InStr(strCurLine, "]")
                                    arrResults(9, intLC) = Mid(strCurLine, intStart + 1, intEnd - intStart - 1)
                                End If
                            ElseIf (InStr(strCurLine, "(0088,0130)") Or InStr(strCurLine, "(0008,0056)")) Then
                                'Storage status
                                intStart = InStr(strCurLine, "[")
                                If (Not intStart = 0) Then
                                    intEnd = InStr(strCurLine, "]")
                                    arrResults(10, intLC) = Mid(strCurLine, intStart + 1, intEnd - intStart - 1)
                                    If (arrResults(10, intLC) = "INSTORE ") Then
                                        arrResults(10, intLC) = "ONLINE"
                                    End If
                                End If
                            ElseIf (InStr(strCurLine, "(0020,000d)")) Then
                                'StudyInstanceUID
                                intStart = InStr(strCurLine, "[")
                                If (Not intStart = 0) Then
                                    intEnd = InStr(strCurLine, "]")
                                    arrResults(11, intLC) = Mid(strCurLine, intStart + 1, intEnd - intStart - 1)
                                End If
                            ElseIf (InStr(strCurLine, "(0000,0902)")) Then
                                'Error Comment
                                intStart = InStr(strCurLine, "[")
                                If (Not intStart = 0) Then
                                    intEnd = InStr(strCurLine, "]")
                                    strErrorComment = Mid(strCurLine, intStart + 1, intEnd - intStart - 1)
                                End If
                            ElseIf (InStr(strCurLine, "C-Find RSP")) Then
                                'Status message
                                intStatusFound += 1
                                If (InStr(strCurLine, "Status=Success") = 0) Then
                                    intSuccess = -1
                                    intStart = InStr(strCurLine, "[")
                                    If (Not intStart = 0) Then
                                        intEnd = InStr(strCurLine, "]")
                                        strErrorComment2 = Mid(strCurLine, intStart + 1, intEnd - intStart - 1)
                                    End If
                                End If
                            ElseIf (InStr(strCurLine, "0006:0317")) Then
                                'Status message
                                intStatusFound += 1
                                intStart = InStr(strCurLine, " ")
                                If (Not intStart = 0 And intLC < Session("regMax_Results")) Then
                                    Session("ErrorMessages") = Session("ErrorMessages") & "PACS Archive " & arrStores(0, intLC2) & " had an error of " & Right(strCurLine, Len(strCurLine) - intStart) & "<br />"
                                    intError = 1
                                End If
                            ElseIf (InStr(strCurLine, "--------")) Then
                                arrResults(13, intLC) = arrStores(0, intLC2)
                                intLC += 1
                                ReDim Preserve arrResults(13, intLC)
                            End If
                        End If
                    End While
                    If (intSuccess = -1) Then
                        If (strErrorComment = "") Then
                            Session("ErrorMessages") = Session("ErrorMessages") & "PACS Archive " & arrStores(0, intLC2) & " had an error of " & strErrorComment2 & "<br />"
                            QueryResults.Visible = False
                            intError = 1
                        Else
                            Session("ErrorMessages") = Session("ErrorMessages") & "PACS Archive " & arrStores(0, intLC2) & " had an error of " & strErrorComment & "<br />"
                            QueryResults.Visible = False
                            intError = 1
                        End If
                    ElseIf (intStatusFound = 0) Then
                        Session("ErrorMessages") = Session("ErrorMessages") & "PACS Archive " & arrStores(0, intLC2) & " had an error of UNKNOWN ERROR<br />"
                        QueryResults.Visible = False
                        intError = 1
                    End If
                    objStreamReader.Close()
                End If
                'Response.Write("ubound(arrResults, 2) = " & UBound(arrResults, 2) & " intLC = " & intLC & " arrResults(1, " & intLC - 1 & ") = " & arrResults(1, intLC - 1) & " <br />")
            Next intLC3
        Next intLC2
        If (intLC < 1) Then
            If (Not intError = 1) Then
                Session("ErrorMessages") = Session("ErrorMessages") & "No results found.<br />"
            End If
        Else
            Session("HaveResults") = 1
        End If
        Session("NumResults") = intLC
        If (intIsSorting = False) Then
            Session("SortType") = "int"
            Session("SortCol") = "4"
            Session("SortOrder") = "DESC"
            SortArray(Session("SortCol"), Session("SortOrder"), Session("SortType"))
        End If
    End Sub
    '    Sub Filter_Responses()
    '   If (Session("sub") = "NEURO") Then
    '          Filter_DB("ccviadyn02")
    '          Filter_DB("ccviadyn03")
    '         Filter_DB("ccviadyn05")
    ' ElseIf (Session("sub") = "CARDIO") Then
    '         Filter_DB("ccviadyn01")
    'ElseIf (Session("sub") = "CARDIO2") Then
    '       Filter_DB("ccviadyn04")
    'Else
    '       Filter_DB("localhost")
    'End If
    ' End Sub
    'Sub Filter_DB(ByVal HostName As String)
    'Dim SQLConn As SqlConnection = New SqlConnection
    'Dim strCommand As String
    'Dim intLC As Integer = Session("NumResults")

    'SQLConn.ConnectionString = "Data Source=" & HostName & ";" & _
    '"Initial Catalog=mvf;" & _
    '"User ID=" & Session("db_name") & ";" & _
    '"Password=" & Session("db_pass") & ";"
    'SQLConn.Open()

    'For i As Integer = 0 To intLC - 1
    'strCommand = "select convert (varchar, count (study_uid)) from mvf.dbo.dosr_study ms where study_uid = '" & arrResults(11, i) & "'"
    'Dim SQLCommand As New SqlClient.SqlCommand(strCommand, SQLConn)
    'Dim reader As SqlDataReader = SQLCommand.ExecuteReader()
    'While reader.Read()
    'Response.Write(reader(0) & "<br />")
    'If (Not reader(0) = 0) Then
    'arrResults(12, i) = "1"
    'End If
    'Response.Write(i & " : " & arrResults(11, i) & " : " & arrResults(12, i) & "<br />")
    'End While
    'reader.Close()
    'Next
    'SQLConn.Close()
    'End Sub
    Sub Write_Responses()
        Dim intLC As Integer = Session("NumResults")
        Dim intlc2 As Integer = 0

        qr.Columns.Add("id", Type.GetType("System.String"))
        qr.Columns.Add("name", Type.GetType("System.String"))
        qr.Columns.Add("dob", Type.GetType("System.String"))
        qr.Columns.Add("accn", Type.GetType("System.String"))
        qr.Columns.Add("date", Type.GetType("System.String"))
        qr.Columns.Add("time", Type.GetType("System.String"))
        qr.Columns.Add("modality", Type.GetType("System.String"))
        qr.Columns.Add("description", Type.GetType("System.String"))
        qr.Columns.Add("series", Type.GetType("System.String"))
        qr.Columns.Add("images", Type.GetType("System.String"))
        qr.Columns.Add("status", Type.GetType("System.String"))
        qr.Columns.Add("SUID", Type.GetType("System.String"))
        qr.Columns.Add("archive", Type.GetType("System.String"))
        For i As Integer = 0 To intLC - 1
            If (arrResults(12, i) = 0 And Not arrResults(0, i) = "") Then
                If (intlc2 >= Session("regMax_Results")) Then
                    Session("perrormessage") = "Maximum allowed results are " & Session("regMax_Results") & ".  Not all results are displayed.<br />"
                    Exit For
                End If
                qr.Rows.Add()
                qr.Rows(qr.Rows.Count - 1)("id") = arrResults(0, i)
                qr.Rows(qr.Rows.Count - 1)("name") = arrResults(1, i)
                qr.Rows(qr.Rows.Count - 1)("dob") = arrResults(2, i)
                qr.Rows(qr.Rows.Count - 1)("accn") = arrResults(3, i)
                qr.Rows(qr.Rows.Count - 1)("date") = arrResults(4, i)
                qr.Rows(qr.Rows.Count - 1)("time") = arrResults(5, i)
                qr.Rows(qr.Rows.Count - 1)("modality") = arrResults(6, i)
                qr.Rows(qr.Rows.Count - 1)("description") = arrResults(7, i)
                qr.Rows(qr.Rows.Count - 1)("series") = arrResults(8, i)
                qr.Rows(qr.Rows.Count - 1)("images") = arrResults(9, i)
                qr.Rows(qr.Rows.Count - 1)("status") = arrResults(10, i)
                qr.Rows(qr.Rows.Count - 1)("SUID") = arrResults(11, i)
                qr.Rows(qr.Rows.Count - 1)("archive") = arrResults(13, i)
                intlc2 += 1
            End If
        Next
        If (intlc2 = 0 And Session("HaveResults") = 1) Then
            Session("ErrorMessages") = Session("ErrorMessages") & "No results found.<br />"
        ElseIf (InStr(Session("ErrorMessages"), "No results found") = False And Session("HaveDate") = 0) Then
            Session("ErrorMessages") = Session("ErrorMessages") & "Notice: Displayed results are from studies performed in the last 365 days.<br />"
        End If
        QueryResults.DataSource = qr
        QueryResults.PageIndex = 0
        QueryResults.DataBind()
    End Sub
    Protected Sub make_row_link(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs)
        If e.Row.RowType = DataControlRowType.Header Then
            Dim img As New Image
            If (Session("SortOrder") = "ASC") Then
                img.ImageUrl = "up_sort.gif"
                If (Not IsNumeric(Session("SortCol"))) Then
                    Session("SortCol") = "4"
                End If
                e.Row.Cells(Session("SortCol")).Controls.Add(New LiteralControl(" "))
                e.Row.Cells(Session("SortCol")).Controls.Add(img)
            ElseIf (Session("SortOrder") = "DESC") Then
                img.ImageUrl = "down_sort.gif"
                If (Not IsNumeric(Session("SortCol"))) Then
                    Session("SortCol") = "4"
                End If
                e.Row.Cells(Session("SortCol")).Controls.Add(New LiteralControl(" "))
                e.Row.Cells(Session("SortCol")).Controls.Add(img)
            End If
        End If
        If (e.Row.RowType = DataControlRowType.DataRow) Then
            Dim row As GridViewRow = QueryResults.SelectedRow
            e.Row.Attributes.Add("onmouseover", "this.style.cursor='hand';this.style.textDecoration='underline';")
            e.Row.Attributes.Add("onmouseout", "this.style.textDecoration='none';")
            e.Row.Attributes.Add("ondblclick", ClientScript.GetPostBackClientHyperlink(Me.QueryResults, "Select$" + e.Row.RowIndex.ToString()))
            'e.Row.Attributes.Add("onClick", "window.open('default.aspx?rs=" & e.Row.RowIndex & "');")
        End If
    End Sub
    Sub SortArray(ByVal intIndex As Integer, ByVal strOrder As String, ByVal strType As String)
        'strOrder can only be ASC or DESC
        'strType can only be int(integer) or str(string)
        Dim arrResultsSort(13, UBound(arrResults, 2)) As String
        Dim strLowestValue, strHighestValue As String
        Dim dblLowestValue, dblHighestValue As Double
        Dim intNewIndex, intLowestIndex As Integer

        If (strType = "int") Then
            If (strOrder = "ASC") Then
                intNewIndex = 0
                intLowestIndex = 0
                dblHighestValue = 0
                'First we need to find the highest value so that we can compare.
                For i As Integer = 0 To UBound(arrResults, 2)
                    If (arrResults(intIndex, i) > dblHighestValue) Then
                        dblHighestValue = arrResults(intIndex, i)
                        intLowestIndex = i
                        'Response.Write("Highest value = " & dblHighestValue & " index = " & intLowestIndex & "<br />")
                    End If
                Next i
                dblLowestValue = dblHighestValue

                For j As Integer = 0 To UBound(arrResults, 2) - 1
                    For k As Integer = 0 To UBound(arrResults, 2) - 1
                        If (arrResults(intIndex, k) <= dblHighestValue And arrResults(intIndex, k) <= dblLowestValue And Not arrResults(intIndex, k) = -1) Then
                            dblLowestValue = arrResults(intIndex, k)
                            intLowestIndex = k
                        End If
                    Next k
                    dblLowestValue = dblHighestValue
                    For intL As Integer = 0 To 13
                        arrResultsSort(intL, intNewIndex) = arrResults(intL, intLowestIndex)
                    Next
                    arrResults(intIndex, intLowestIndex) = -1
                    intNewIndex += 1
                Next j
                For i As Integer = 0 To UBound(arrResults, 2)
                    For intL As Integer = 0 To 13
                        arrResults(intL, i) = arrResultsSort(intL, i)
                    Next
                Next
            ElseIf (strOrder = "DESC") Then
                intNewIndex = 0
                intLowestIndex = 0
                dblHighestValue = 0
                'First we need to find the lowest value so that we can compare.
                For i As Integer = 0 To UBound(arrResults, 2)
                    If (arrResults(intIndex, i) < dblHighestValue) Then
                        dblHighestValue = arrResults(intIndex, i)
                        intLowestIndex = i
                    End If
                Next i
                dblLowestValue = dblHighestValue

                For j As Integer = 0 To UBound(arrResults, 2) - 1
                    For k As Integer = 0 To UBound(arrResults, 2) - 1
                        If (arrResults(intIndex, k) >= dblHighestValue And arrResults(intIndex, k) >= dblLowestValue And Not arrResults(intIndex, k) = -1) Then
                            dblLowestValue = arrResults(intIndex, k)
                            intLowestIndex = k
                        End If
                    Next k
                    dblLowestValue = dblHighestValue
                    For intL As Integer = 0 To 13
                        arrResultsSort(intL, intNewIndex) = arrResults(intL, intLowestIndex)
                    Next
                    arrResults(intIndex, intLowestIndex) = -1
                    intNewIndex += 1
                Next j
                For i As Integer = 0 To UBound(arrResults, 2)
                    For intL As Integer = 0 To 13
                        arrResults(intL, i) = arrResultsSort(intL, i)
                    Next
                Next
            End If
        ElseIf (strType = "str") Then
            If (strOrder = "ASC") Then
                intNewIndex = 0
                intLowestIndex = 0
                strHighestValue = 0
                'First we need to find the highest value so that we can compare.

                For i As Integer = 0 To UBound(arrResults, 2)
                    If (arrResults(intIndex, i) > strHighestValue) Then
                        strHighestValue = arrResults(intIndex, i)
                        intLowestIndex = i
                    End If
                Next i
                strLowestValue = strHighestValue

                For j As Integer = 0 To UBound(arrResults, 2) - 1
                    For k As Integer = 0 To UBound(arrResults, 2) - 1
                        If (arrResults(intIndex, k) <= strHighestValue And arrResults(intIndex, k) <= strLowestValue And Not arrResults(intIndex, k) = "-1") Then
                            strLowestValue = arrResults(intIndex, k)
                            intLowestIndex = k
                        End If
                    Next k
                    strLowestValue = strHighestValue
                    For intL As Integer = 0 To 13
                        arrResultsSort(intL, intNewIndex) = arrResults(intL, intLowestIndex)
                    Next intL
                    arrResults(intIndex, intLowestIndex) = "-1"
                    intNewIndex += 1
                Next j
                For i As Integer = 0 To UBound(arrResults, 2)
                    For intL As Integer = 0 To 13
                        arrResults(intL, i) = arrResultsSort(intL, i)
                    Next intL
                Next
            ElseIf (strOrder = "DESC") Then
                intNewIndex = 0
                intLowestIndex = 0
                strHighestValue = 0
                'First we need to find the lowest value so that we can compare.
                For i As Integer = 0 To UBound(arrResults, 2)
                    If (arrResults(intIndex, i) < strHighestValue) Then
                        strHighestValue = arrResults(intIndex, i)
                        intLowestIndex = i
                    End If
                Next i
                strLowestValue = strHighestValue

                For j As Integer = 0 To UBound(arrResults, 2) - 1
                    For k As Integer = 0 To UBound(arrResults, 2) - 1
                        If (arrResults(intIndex, k) >= strHighestValue And arrResults(intIndex, k) >= strLowestValue And Not arrResults(intIndex, k) = "-1") Then
                            strLowestValue = arrResults(intIndex, k)
                            intLowestIndex = k
                        End If
                    Next k
                    strLowestValue = strHighestValue
                    For intL As Integer = 0 To 13
                        arrResultsSort(intL, intNewIndex) = arrResults(intL, intLowestIndex)
                    Next intL
                    arrResults(intIndex, intLowestIndex) = "-1"
                    intNewIndex += 1
                Next j
                For i As Integer = 0 To UBound(arrResults, 2)
                    For intL As Integer = 0 To 13
                        arrResults(intL, i) = arrResultsSort(intL, i)
                    Next intL
                Next
            End If
        End If

        'Sort on Study Time in addition to the date
        If (intIndex = 4) Then
            Dim intLowestValue As Integer
            For i As Integer = 0 To UBound(arrResults, 2) - 1
                If (arrResults(intIndex, i) = arrResults(intIndex, i + 1)) Then
                    'We have more than one study on the same date.  Let's sort them
                    Dim intDate As Integer = arrResults(intIndex, i)
                    Dim intTime As Integer = arrResults(5, i)
                    Dim intCurIndex As Integer = i
                    Dim intNumStudies As Integer = 1
                    For j As Integer = i + 1 To UBound(arrResults, 2) - 1
                        'Need to find out how many studies we have on this date.  Iterate through the array and find them all
                        'This assumes that all dates are grouped together
                        If (arrResults(intIndex, j) = intDate) Then
                            intNumStudies += 1
                        Else
                            Exit For
                        End If
                    Next j
                    For k As Integer = i To intNumStudies + i - 1
                        'Find first available value
                        For m As Integer = intCurIndex To intNumStudies + intCurIndex - 1
                            If (Not arrResults(5, m) = -1) Then
                                intLowestIndex = m
                                intLowestValue = arrResults(5, m)
                            End If
                        Next m
                        If (strOrder = "ASC") Then
                            'Find the lowest value
                            For l As Integer = i To intNumStudies + i - 1
                                If (arrResults(5, l) <= intLowestValue And Not arrResults(5, l) = -1) Then
                                    intLowestIndex = l
                                    intLowestValue = arrResults(5, l)
                                End If
                            Next l
                        Else
                            'Find the highest value
                            For l As Integer = i To intNumStudies + i - 1
                                If (arrResults(5, l) >= intLowestValue And Not arrResults(5, l) = -1) Then
                                    intLowestIndex = l
                                    intLowestValue = arrResults(5, l)
                                End If
                            Next l
                        End If
                        'Got the lowest (or highest) value, let's write it to the array
                        For intL As Integer = 0 To 13
                            arrResultsSort(intL, k) = arrResults(intL, intLowestIndex)
                        Next
                        arrResults(5, intLowestIndex) = -1
                    Next k
                    i += intNumStudies - 1
                Else
                    For intL As Integer = 0 To 13
                        arrResultsSort(intL, i) = arrResults(intL, i)
                    Next
                    arrResults(5, i) = -1
                End If
            Next i
            For i As Integer = 0 To UBound(arrResults, 2)
                For intL As Integer = 0 To 13
                    arrResults(intL, i) = arrResultsSort(intL, i)
                Next intL
            Next
        End If
    End Sub
    Sub ReadRegistry()
        Dim pRegKey As RegistryKey = Registry.LocalMachine
        Dim strConfigFile, strCurLine As String
        Dim intLC, intLC2, intDone, intStartPos, intEndPos, intTemp As Integer

        strConfigFile = "\inetpub\wwwroot\Workplace_DICOM_QR_tool\config\config.txt"
        'If (System.IO.File.Exists(strConfigFile)) Then
        Dim objStreamReader As StreamReader
        objStreamReader = File.OpenText(strConfigFile)
        intLC = 0
        intLC2 = 0
        intDone = 0
        While (Not objStreamReader.EndOfStream And Not intDone = 1)
            strCurLine = objStreamReader.ReadLine
            'This should store the maximum number of queries that can be running simultaniously"

            If (Left(strCurLine, 2) = "mq") Then
                intStartPos = InStr(strCurLine, "|")
                intEndPos = InStr(intStartPos, strCurLine, "|")
                If (intEndPos <= intStartPos) Then
                    Session("regQueues") = Right(strCurLine, strCurLine.Length - intStartPos)
                Else
                    Session("regQueues") = Mid(strCurLine, intStartPos, intEndPos - intStartPos)
                End If
                Session("regQueues") = Trim(Session("regQueues"))
            ElseIf (Left(strCurLine, 3) = "PID") Then
                intStartPos = InStr(strCurLine, "|")
                intEndPos = InStr(intStartPos, strCurLine, "|")
                If (intEndPos <= intStartPos) Then
                    Session("regPID") = Right(strCurLine, strCurLine.Length - intStartPos)
                Else
                    Session("regPID") = Mid(strCurLine, intStartPos, intEndPos - intStartPos)
                End If
                Session("regPID") = Trim(Session("regPID"))
            ElseIf (Left(strCurLine, 2) = "NF") Then
                intStartPos = InStr(strCurLine, "|")
                intEndPos = InStr(intStartPos, strCurLine, "|")
                If (intEndPos <= intStartPos) Then
                    Session("regNF") = Right(strCurLine, strCurLine.Length - intStartPos)
                Else
                    Session("regNF") = Mid(strCurLine, intStartPos, intEndPos - intStartPos)
                End If
            ElseIf (Left(strCurLine, 2) = "WC") Then
                intStartPos = InStr(strCurLine, "|")
                intEndPos = InStr(intStartPos, strCurLine, "|")
                If (intEndPos <= intStartPos) Then
                    Session("regWC") = Right(strCurLine, strCurLine.Length - intStartPos)
                Else
                    Session("regWC") = Mid(strCurLine, intStartPos, intEndPos - intStartPos)
                End If
            ElseIf (Left(strCurLine, 2) = "mr") Then
                intStartPos = InStr(strCurLine, "|")
                intEndPos = InStr(intStartPos, strCurLine, "|")
                If (intEndPos <= intStartPos) Then
                    Session("regMax_Results") = Right(strCurLine, strCurLine.Length - intStartPos)
                Else
                    Session("regMax_Results") = Mid(strCurLine, intStartPos, intEndPos - intStartPos)
                End If
                Session("regMax_Results") = Trim(Session("regMax_Results"))
            ElseIf (Left(strCurLine, 2) = "mv") Then
                intStartPos = InStr(strCurLine, "|")
                intEndPos = InStr(intStartPos, strCurLine, "|")
                If (intEndPos <= intStartPos) Then
                    Session("regMV") = Right(strCurLine, strCurLine.Length - intStartPos)
                Else
                    Session("regMV") = Mid(strCurLine, intStartPos, intEndPos - intStartPos)
                End If
                Session("regMV") = Trim(Session("regMV"))
            ElseIf (Left(strCurLine, 2) = "db") Then
                intStartPos = InStr(strCurLine, "|")
                intEndPos = InStr(intStartPos + 1, strCurLine, "|")
                Session("db_name") = Trim(Mid(strCurLine, intStartPos + 1, intEndPos - intStartPos - 1))
                intStartPos = InStr(intEndPos, strCurLine, "|")
                intEndPos = strCurLine.Length - intStartPos
                Session("db_pass") = Trim(Right(strCurLine, intEndPos))
                ElseIf (Left(strCurLine, 2) = "is") Then
                'Format: <"is"> <store name> <store IP> <store port> <store AET>
                If (Not intLC2 = 0) Then
                    ReDim Preserve arrStores(6, intLC2 + 1)
                End If
                If (Not intLC2 > 8) Then
                    intStartPos = InStr(strCurLine, "|")
                    intEndPos = InStr(intStartPos + 1, strCurLine, "|")
                    arrStores(0, intLC2) = Trim(Mid(strCurLine, intStartPos + 1, intEndPos - intStartPos - 1))
                    intStartPos = InStr(intEndPos, strCurLine, "|")
                    intEndPos = InStr(intStartPos + 1, strCurLine, "|")
                    arrStores(1, intLC2) = Trim(Mid(strCurLine, intStartPos + 1, intEndPos - intStartPos - 1))
                    intStartPos = InStr(intEndPos, strCurLine, "|")
                    intEndPos = InStr(intStartPos + 1, strCurLine, "|")
                    arrStores(2, intLC2) = Trim(Mid(strCurLine, intStartPos + 1, intEndPos - intStartPos - 1))
                    intStartPos = InStr(intEndPos, strCurLine, "|")
                    intEndPos = InStr(intStartPos + 1, strCurLine, "|")
                    arrStores(3, intLC2) = Trim(Mid(strCurLine, intStartPos + 1, intEndPos - intStartPos - 1))
                    intStartPos = InStr(intEndPos, strCurLine, "|")
                    intEndPos = strCurLine.Length - intStartPos
                    arrStores(4, intLC2) = Trim(Right(strCurLine, intEndPos))
                    intLC2 += 1
                End If
            End If
            intLC += 1
            If (intLC > 10000) Then
                intDone = 1
            End If
        End While
        objStreamReader.Close()
        Session("Archive") = "All"
        Session("OArchive") = "All"
        For i As Integer = 0 To UBound(arrStores, 2) - 1
            If (arrStores(4, i) = "yes") Then
                Session("Archive") = arrStores(0, i)
                Session("OArchive") = arrStores(0, i)
            End If
        Next
    End Sub
    Sub AddFormItems()
        Dim intIndex As Integer

        If (UBound(arrStores, 2) > 1) Then
            CClear.Visible = True
            Archive_Title.Visible = True
            Archive_Action.Visible = True
            clear.Visible = False
            intIndex = Archives.SelectedIndex
            Archives.Items.Clear()
            Archives.Items.Add(New ListItem("All", "All"))
            For i As Integer = 0 To UBound(arrStores, 2) - 1
                Archives.Items.Add(New ListItem(arrStores(0, i), arrStores(0, i)))
            Next
            Archives.SelectedIndex = intIndex
        Else
            CClear.Visible = False
            Archive_Title.Visible = False
            Archive_Action.Visible = False
            clear.Visible = True
            Archives.Visible = False
        End If
    End Sub
    Sub RePopulateSessionVars()
        Dim daDayToday As Date = Now
        Dim daDayYesterday As Date = Now
        Dim daDayDayBefore As Date = Now

        daDayYesterday = daDayYesterday.AddDays(-1)
        daDayDayBefore = daDayDayBefore.AddDays(-2)

        If (ddate.SelectedItem.Value = "Today") Then
            ddate_text.Text = Format(daDayToday.Date, "yyyyMMdd")
            ddate_text.Text = Format(daDayToday.Date, "yyyyMMdd")
            Session("pdate") = Format(daDayToday.Date, "yyyyMMdd")
        ElseIf (ddate.SelectedItem.Value = "Yesterday") Then
            ddate_text.Text = Format(daDayYesterday.Date, "yyyyMMdd")
            ddate_text.Text = Format(daDayYesterday.Date, "yyyyMMdd")
            Session("pdate") = Format(daDayYesterday.Date, "yyyyMMdd")
        ElseIf (ddate.SelectedItem.Value = "3") Then
            ddate_text.Text = Format(daDayToday.Date, "yyyyMMdd") & "-" & Format(daDayDayBefore.Date, "yyyyMMdd")
            ddate_text.Text = Format(daDayToday.Date, "yyyyMMdd") & "-" & Format(daDayDayBefore.Date, "yyyyMMdd")
            Session("pdate") = Format(daDayToday.Date, "yyyyMMdd") & "-" & Format(daDayDayBefore.Date, "yyyyMMdd")
        ElseIf (ddate.SelectedItem.Value = "*") Then
            ddate_text.Text = "*"
            Session("pdate") = ddate_text.Text
        ElseIf (ddate.SelectedItem.Value = "na" And InStr(ddate_text.Text, "-")) Then
            ddate_text.Text = "*"
            Session("pdate") = ddate_text.Text
        ElseIf (ddate_text.Text <> "") Then
            Session("pdate") = ddate_text.Text
        Else
            Session("pdate") = "*"
        End If
    End Sub
    Sub PopulaeSessionVars()
        Dim daDayToday As Date = Now
        Dim daDayYesterday As Date = Now
        Dim daDayDayBefore As Date = Now
        Dim strURL, strTemp, strName, strValue, strTempName, strTempValue As String
        Dim intOccurances, intOccurances2, intPos1, intPos2, intCurPos, intLC, intStartPos, intCurSeperator As Integer

        daDayYesterday = daDayYesterday.AddDays(-1)
        daDayDayBefore = daDayDayBefore.AddDays(-2)

        Session("URL") = Request.Url.ToString()
        'There is probably a built in way to parse GET data but I couldn't find it.  So I will write my own
        strURL = Request.Url.ToString()
        Dim exp As New Regex("\?", RegexOptions.IgnoreCase)
        intOccurances = exp.Matches(strURL).Count
        Dim exp2 As New Regex("\=", RegexOptions.IgnoreCase)
        intOccurances2 = exp2.Matches(strURL).Count

        If (Not IsPostBack) Then
            If (intOccurances2 > 0) Then
                intLC = 0
                intCurPos = 0
                intStartPos = InStr(strURL, "?")
                intCurSeperator = InStr(strURL, "=")
                If (InStr(strURL, "&") = 0) Then
                    intPos2 = strURL.Length + 1
                Else
                    intPos2 = InStr(intStartPos + 1, strURL, "&")
                End If

                strTempName = Mid(strURL, intStartPos + 1, intCurSeperator - intStartPos - 1)
                strTempValue = Mid(strURL, intCurSeperator + 1, intPos2 - intCurSeperator - 1)
                Session(strTempName) = strTempValue
                intCurPos = intPos2
                'Response.Write(intLC & " strName = " & strTempName & " strValue = " & strTempValue & "<br />")

                While (intLC < intOccurances2 - 1)
                    intPos2 = InStr(intCurPos + 1, strURL, "=")
                    strTempName = Mid(strURL, intCurPos + 1, intPos2 - intCurPos - 1)
                    intCurPos = intPos2
                    intPos2 = InStr(intCurPos + 1, strURL, "&")
                    If (intPos2 = 0) Then
                        strTempValue = Right(strURL, Len(strURL) - intCurPos)
                    Else
                        strTempValue = Mid(strURL, intCurPos + 1, intPos2 - intCurPos - 1)
                    End If
                    intCurPos = intPos2
                    Session(strTempName) = strTempValue
                    'Response.Write(intLC & " strName = " & strTempName & " strValue = " & strTempValue & "<br />")
                    intLC = intLC + 1
                End While
            End If
        End If

        Session("opname") = Session("pn")
        Session("opid") = Session("pid")
        Session("opaccn") = Session("paccn")
        Session("opsub") = Session("sub")

        Session("pname") = Session("pn")
        Session("pid") = Session("pid")
        Session("paccn") = Session("paccn")
        Session("psub") = Session("sub")

        pn.Text = Session("pname")
        pid.Text = Session("pid")
        accn.Text = Session("paccn")
    End Sub
    Sub PopulateInputFields(ByVal intError As Integer)
        'Write session variables to the form for editing

        ErrorMessages.Text = ""
        pn.Text = Session("pname")
        pid.Text = Session("pid")
        desc.Text = Session("pdesc")
        accn.Text = Session("paccn")

        If (Session("pmod") = "CT") Then
            [mod].SelectedIndex = 1
        ElseIf (Session("pmod") = "MR") Then
            [mod].SelectedIndex = 2
        Else
            [mod].SelectedIndex = 0
        End If

        ddate_text.Text = Session("pdate")

        If (Not intError = 0) Then
            ErrorMessages.Text = "<div id=""message"">" & Session("perrormessage") & "</div>" & Session("perrormessage2")
        End If
    End Sub
    Sub Get_Hostname()
        Dim intLen As Integer
        Dim myHost As String = System.Net.Dns.GetHostName
        'Dim myIPs As System.Net.IPHostEntry = System.Net.Dns.GetHostEntry(myHost)

        If (InStr(myHost.ToString, ".")) Then
            intLen = InStr(myHost.ToString, ".")
            Session("HostName") = UCase(Left(myHost.ToString, intLen - 1))
        Else
            Session("HostName") = UCase(myHost.ToString)
        End If
        'Temporary fix for testing.  The above line should be uncommented and the below line removed before going to production
        'Session("HostName") = "VMWARE01"
    End Sub

    Private Sub Form1_load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.Load

    End Sub
    Protected Sub page_load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Page.Response.Cache.SetCacheability(HttpCacheability.NoCache)
    End Sub

End Class
