﻿<%@ Page Language="VB" AutoEventWireup="false" CodeFile="Default.aspx.vb" Inherits="_Default" EnableEventValidation="false" %> 

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
    <title>Siemens syngo Dynamics Query/Retrieve</title>
    <!-- Written by Will Yonker-->
    <link href="StyleSheet.css" rel="Stylesheet" type="text/css" />
    <script type="text/javascript">
        function RowOn(Row) {
            Row.style.backgroundColor = "#2A2A39";
            Row.style.color = "#FFFFFF";
            Row.style.cursor = "hand";
        }
        function RowOff(Row) {
            Row.style.backgroundColor = "#212131";
            Row.style.color = "#DFDFDF";
        }
        function RowDown(Row) {
            Row.style.backgroundColor = "#FF0000";
        }
    </script>

</head>
<body id="mBody" text="#DFDFDF" bgcolor="#212131" runat="server">
<h3>Search Criteria</h3>
<form id="Form1" name="form1" method="post" runat="server">
     <table>
        <tr><td>Patient Name</td><td>Patient ID</td><td>Study Description</td></tr>
        <tr><td><asp:TextBox id="pn" runat="server" BackColor="#2A2A39" 
                ForeColor="#DFDFDF" BorderColor="Black" BorderStyle="Solid" ></asp:TextBox>
             </td>
        <td><asp:TextBox id="pid" runat="server" Text="pid" BackColor="#2A2A39" 
                ForeColor="#DFDFDF" BorderColor="Black" BorderStyle="Solid" /></td>
        <td><asp:TextBox id="desc" runat="server" Text="pdesc" BackColor="#2A2A39" 
                ForeColor="#DFDFDF" BorderColor="Black" BorderStyle="Solid" /></td>
            <td><asp:Button ID="sub" Text="Query" OnClick="submit" runat="server" 
                BorderColor="Black" BorderStyle="Solid" BackColor="#323243" ForeColor="#DFDFDF" />
                </td><td><asp:Button id="reset" text="Reset" OnClick="Run_Reset" runat="server" 
                BorderColor="Black" BorderStyle="Solid" BackColor="#323243" ForeColor="#DFDFDF" />
                </td><td><asp:Button id="CClear" runat="server" Text="Clear" onclick="Run_Clear"
                BorderColor="Black" BorderStyle="Solid" BackColor="#323243" ForeColor="#DFDFDF" />
                </td></tr>
        <tr><td>Accession #</td><td>MOD</td><td>Study Date</td><td></td><td colspan="3">
        <asp:Label ID="Archive_Title" runat="server" Visible="False" Text="Archives" /></td></tr>
        <tr><td><asp:TextBox id="accn" runat="server" Text="paccn" BackColor="#2A2A39" 
                ForeColor="#DFDFDF" BorderColor="Black" BorderStyle="Solid" /></td>
        <td><asp:DropDownList id="mod" runat="server" BackColor="#2A2A39" 
                ForeColor="#DFDFDF" BorderColor="Black" BorderStyle="Solid">
            <asp:ListItem value="*" Selected="True">*</asp:ListItem>
            <asp:ListItem Value="CT">CT</asp:ListItem>
            <asp:ListItem value="MR">MR</asp:ListItem>
            <asp:ListItem value="US">US</asp:ListItem>
            <asp:ListItem value="XA">XA</asp:ListItem>
        </asp:DropDownList></td>
        <td><asp:TextBox ID="ddate_text" runat="server"></asp:TextBox><br />
        <asp:DropDownList ID="ddate" runat="server" BackColor="#2A2A39"
                forecolor="#DFDFDF" bordercolor="Black" borderstyle="Solid" >
            <asp:ListItem value="na" Text="na" Selected="True">Select or enter a date</asp:ListItem>
            <asp:ListItem Value="*" Text="*">All</asp:ListItem>
            <asp:ListItem value="Today" Text="Today">Today</asp:ListItem>
            <asp:ListItem value="Yesterday" Text="Yesterday">Yesterday</asp:ListItem>
            <asp:ListItem value="3" Text="Past Three Days">Past Three Days</asp:ListItem>
            </asp:DropDownList></td>
        <td><asp:Button id="clear" runat="server" Text="Clear" onclick="Run_Clear"
            BorderColor="Black" BorderStyle="Solid" BackColor="#323243" ForeColor="#DFDFDF" /></td>
        <td colspan="3"><asp:DropDownList ID="Archives" runat="server" BackColor="#2A2A39"
            forecolor="#DFDFDF" bordercolor="Black" borderstyle="Solid">
            <asp:ListItem Value="All" Text="All" Selected="True">All</asp:ListItem>
        </asp:DropDownList><br />
        <asp:Label ID="Archive_Action" runat="server" Visible="False" CssClass="archiveaction" />
        </td><td> </td></tr>
    </table>
    <asp:Label ID="ErrorMessages" runat="server" />
    <hr />
    <asp:GridView ID="QueryResults" runat="server" DataKeyNames="ID"
        AutoGenerateColumns = "false" Font-Names = "Arial"
        Font-Size = "11pt" HeaderStyle-BackColor = "#323243" AllowPaging="true" AllowSorting="true"
        PageSize = "16" Caption = "Query Results" OnRowDataBound="make_row_link" 
        onselectedindexchanged="QR_SelectedIndexChanged"
        onPageIndexChanging="QR_PageIndexChanging"
        onSorting="QR_SortChanging" >
        <Columns>
        <asp:BoundField ItemStyle-Width = "150px" SortExpression="0"
            DataField = "id" HeaderText = "PID" HeaderStyle-HorizontalAlign="Center"
            HeaderStyle-VerticalAlign="Middle" />
        <asp:BoundField ItemStyle-Width = "250px" SortExpression="1"
            DataField = "name" HeaderText = "Patient Name" HeaderStyle-HorizontalAlign="Center"
            HeaderStyle-VerticalAlign="Middle" />
        <asp:BoundField ItemStyle-Width = "150px" SortExpression="2"
            DataField = "dob" HeaderText = "DOB" HeaderStyle-HorizontalAlign="Center"
            HeaderStyle-VerticalAlign="Middle" />
        <asp:BoundField ItemStyle-Width = "125px" SortExpression="3"
            DataField = "accn" HeaderText = "ACCN" HeaderStyle-HorizontalAlign="Center"
            HeaderStyle-VerticalAlign="Middle" />
        <asp:BoundField ItemStyle-Width = "125px" SortExpression="4" 
            DataField = "date" HeaderText = "Study Date" HeaderStyle-HorizontalAlign="Center"
            HeaderStyle-VerticalAlign="Middle" HeaderStyle-Wrap="False" HeaderStyle-CssClass="headertext" />
        <asp:BoundField ItemStyle-Width = "100px" 
            DataField = "time" HeaderText = "Study Time" />
        <asp:BoundField ItemStyle-Width = "100px" 
            DataField = "modality" HeaderText = "MOD" ItemStyle-HorizontalAlign="Center" />
        <asp:BoundField ItemStyle-Width = "150px" 
            DataField = "description" HeaderText = "Study Description" />
        <asp:BoundField ItemStyle-Width = "75px" 
            DataField = "series" HeaderText = "# Series" />
        <asp:BoundField ItemStyle-Width = "75px" 
            DataField = "images" HeaderText = "# Images" />
        <asp:BoundField ItemStyle-Width = "150px" 
            DataField = "status" HeaderText = "Status" />
        <asp:BoundField ItemStyle-Width = "0px"
            DataField = "SUID" ItemStyle-CssClass="invisible" HeaderStyle-CssClass="invisible" />
        <asp:BoundField ItemStyle-Width = "0px"
            DataField = "archive" ItemStyle-CssClass="invisible" HeaderStyle-CssClass="invisible" />
        </Columns>
    </asp:GridView>
    </form>
    </body>
</html>

