﻿<%@ Application Language="VB" %>
<%@ Import Namespace="System.IO" %>

<script runat="server">
    Sub Application_Start(ByVal sender As Object, ByVal e As EventArgs)
        ' Code that runs on application startup
    End Sub
    
    Sub Application_End(ByVal sender As Object, ByVal e As EventArgs)
        ' Code that runs on application shutdown
    End Sub
        
    Sub Application_Error(ByVal sender As Object, ByVal e As EventArgs)
        ' Code that runs when an unhandled error occurs
        Dim lastErrorWrapper As HttpException = CType(Server.GetLastError(), HttpException)
        Dim intLC2, intDone As Integer
        Dim strSearchString, strDate, strTime As String
        Dim daDayToday As Date = Now
        Dim objStreamWriter As FileStream

        Dim lastError As Exception = lastErrorWrapper
        If lastErrorWrapper.InnerException IsNot Nothing Then
            lastError = lastErrorWrapper.InnerException
        End If

        Dim lastErrorTypeName As String = lastError.GetType().ToString()
        Dim lastErrorMessage As String = lastError.Message
        Dim lastErrorStackTrace As String = lastError.StackTrace
        
        strDate = Format(daDayToday.Date, "yyyyMMdd")
        strTime = Format(Now(), "T")
        intLC2 = 0
        intDone = 0
        While (intLC2 < 10000 And intDone <> 1)
            strSearchString = "\inetpub\wwwroot\Workplace_DICOM_QR_tool\logs\" & strDate & "_" & intLC2 & "_" & "error_message.txt"
            If (System.IO.File.Exists(strSearchString)) Then
                intLC2 = intLC2 + 1
            Else
                intDone = 1
            End If
        End While
        objStreamWriter = File.OpenWrite(strSearchString)
        Dim strCurLine As Byte() = New UTF8Encoding(True).GetBytes(strDate & " " & strTime & " Error Type: " & lastErrorTypeName & vbCrLf)
        objStreamWriter.Write(strCurLine, 0, strCurLine.Length)
        strCurLine = New UTF8Encoding(True).GetBytes(strDate & " " & strTime & " Error Message: " & lastErrorMessage & vbCrLf)
        objStreamWriter.Write(strCurLine, 0, strCurLine.Length)
        strCurLine = New UTF8Encoding(True).GetBytes(strDate & " " & strTime & " Stack Trace: " & lastErrorStackTrace & vbCrLf)
        objStreamWriter.Write(strCurLine, 0, strCurLine.Length)
        objStreamWriter.Close()
        Session("ErrorMessages") = strSearchString
        Session("lastErrorTypeName") = lastErrorTypeName
        Session("lastErrorMessage") = lastErrorMessage
        Session("lastErrorStackTrace") = lastErrorStackTrace
        Server.Transfer("error.aspx")
    End Sub

    Sub Session_Start(ByVal sender As Object, ByVal e As EventArgs)
        ' Code that runs when a new session is started
    End Sub

    Sub Session_End(ByVal sender As Object, ByVal e As EventArgs)
        ' Code that runs when a session ends. 
        ' Note: The Session_End event is raised only when the sessionstate mode
        ' is set to InProc in the Web.config file. If session mode is set to StateServer 
        ' or SQLServer, the event is not raised.
    End Sub
       
</script>

