﻿<%@ Page Language="VB" AutoEventWireup="false" CodeFile="admin.aspx.vb" Inherits="Default2" EnableEventValidation="false" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
    <title>Siemens syngo Dynamics Query/Retrieve</title>
    <!-- Written by Will Yonker-->
    <link href="StyleSheet.css" rel="Stylesheet" type="text/css" />
    <script type="text/javascript">
        function RowOn(Row) {
            Row.style.backgroundColor = "#2A2A39";
            Row.style.color = "#FFFFFF";
            Row.style.cursor = "hand";
        }
        function RowOff(Row) {
            Row.style.backgroundColor = "#212131";
            Row.style.color = "#DFDFDF";
        }
        function RowDown(Row) {
            Row.style.backgroundColor = "#FF0000";
        }
        function showdest(obj1) {
            document.getElementById("Panel1").style.display = "block";
        }
        function hidedest(obj2) {
            document.getElementById("Panel1").style.display = "none";
        }
    </script>

</head>
<body onload="window.resizeTo(900,700);" text="#DFDFDF" bgcolor="#212131" >
    <form id="form1" runat="server">
    <h3 align="center">Configuration</h3>
    <div>
        <div class="floatright">
            <center><b>LOGS</b></center><br />
            <asp:Label ID="Logs" runat="server"></asp:Label>
            <center><asp:Button ID="PurgeLogs" runat="server" Text="Purge" onclick="PurgeLogsSub" /></center>
        </div>
        Maximum number of running DICOM transfers:<br />
        <asp:TextBox ID="MaxQueues" runat="server" />
        <br /><br />
        MRN Record type:<br />
        <asp:RadioButton ID="non" text="Standard" groupname="PID" runat="server" onclick="hidedest(this)" /><br />
        <asp:radiobutton id="CCF" text="Cleveland Clinic" GroupName="PID" runat="server" onclick="showdest(this)" />
        <br />
        <asp:Panel ID="Panel1" runat="server" style="display:none">
            Move Destination:<br />
            <asp:TextBox ID="movedest" runat="server" />
        </asp:Panel>
        <br /><br />
        Maximum number of displayed query results:<br />
        <asp:TextBox ID="MaxResults" runat="server" />
        <br /><br />
        <div class="floatright">
            <center><b>Running Moves</b></center><br />
            <asp:Label ID="Moves" runat="server"></asp:Label>
            <center><asp:Button ID="ClearQueue" runat="server" Text="Cancel All" OnClick="ClearQueueSub" /></center>
        </div>
        Patient Name format (how names are stored on the archive(s)):<br />
        <asp:radiobutton ID="nflower" text="All lower case names" groupname="NF" runat="server" /><br />
        <asp:RadioButton ID="nfupper" Text="All upper case names" GroupName="NF" runat="server" /><br />
        <asp:RadioButton ID="nfmixed" Text="Names contain both lower and upper case" GroupName="NF" runat="server" /><br />
        <br />
        Allow full wildcard seaches:<br />
        <asp:RadioButton ID="wcno" Text="Patient name, patient ID or study date must be defined" GroupName="WC" runat="server" /><br />
        <asp:RadioButton ID="wcyes" Text="Patient name, patient ID and study date can all be * (Dangerous)" GroupName="WC" runat="server" /><br />
        <br />
        <h3 align="center">Local Dynamics database user information</h3>
        DB User Name
        <asp:TextBox ID="DBName" runat="server" /><br /><br />
        DB Password
        <asp:TextBox ID="DBPass" runat="server" TextMode="Password" /><br /><br />
        <br /><br /><br />
        <asp:Button ID="Sub" runat="server" Text="Submit" OnClick="submit" />
        <asp:GridView ID="ImageServers" runat="server"
            AutoGenerateColumns = "false" Font-Names = "Arial" CssClass="MyLinkButtons"
            Font-Size = "11pt" HeaderStyle-BackColor = "#323243" AllowPaging ="true"  
            PageSize = "10" Caption = "PACS Archives" OnRowDeleting="ImageServers_RowDeleting"
            autogeneratedeletebutton="False" OnRowDataBound="make_row_link" 
            onselectedindexchanged="IS_SelectedIndexChanged" >
            <Columns>
            <asp:CommandField ShowDeleteButton="true" >
                <ControlStyle ForeColor="white" />
            </asp:CommandField>
            <asp:BoundField ItemStyle-Width = "150px"
                DataField = "name" HeaderText = "Name" />
            <asp:BoundField ItemStyle-Width = "150px"
                DataField = "ip" HeaderText = "IP" />
            <asp:BoundField ItemStyle-Width = "150px"
                DataField = "port" HeaderText = "Port" />
            <asp:BoundField ItemStyle-Width = "150px"
                DataField = "aet" HeaderText = "AET" />
            <asp:BoundField ItemStyle-Width = "150px"
                DataField = "default" HeaderText = "Default" />
            </Columns>
        </asp:GridView>
        <br />
        Click a row to toggle the default to yes or no.   Only one archive can be the default.<br />
        If no archives are made default, all archives will be queried unless the user specifies otherwise.<br />
        <h3 align="center">Fill out the following to add a PACS archive</h3>
        PACS Archive Name<br />
        <asp:TextBox ID="Name" runat="server" /><br />
        IP Address<br />
        <asp:TextBox ID="ip" runat="server" /><br />
        Port number<br />
        <asp:TextBox ID="port" runat="server" /><br />
        AET Title<br />
        <asp:TextBox ID="aet" runat="server" />
        <br /><br />
        <asp:Button ID="Add" runat="server" Text="Add" OnClick="AddImage" />
    </div>
    </form>
</body>

</html>
