﻿Imports System
Imports System.Data
Imports System.IO
Imports System.Net
Imports Microsoft.Win32
Imports System.Diagnostics
Imports System.Diagnostics.Process
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Security.Permissions
Imports Microsoft.VisualBasic

Partial Class Default2
    Inherits System.Web.UI.Page
    Public regStores, regQueues, regPID, regMax_Results As Object
    Public arrStores(6, 1) As String
    Public intArchives As Integer

    Sub ReadRegistry()
        Dim strConfigFile, strCurLine As String
        Dim intLC, intLC2, intDone, intStartPos, intEndPos As Integer

        strConfigFile = "\inetpub\wwwroot\Workplace_DICOM_QR_tool\config\config.txt"
        If (System.IO.File.Exists(strConfigFile)) Then
            Dim objStreamReader As StreamReader
            objStreamReader = File.OpenText(strConfigFile)
            intLC = 0
            intLC2 = 0
            intDone = 0
            While (Not objStreamReader.EndOfStream And Not intDone = 1)
                strCurLine = objStreamReader.ReadLine
                'This should store the maximum number of queries that can be running simultaniously"

                If (Left(strCurLine, 2) = "mq") Then
                    intStartPos = InStr(strCurLine, "|")
                    intEndPos = InStr(intStartPos, strCurLine, "|")
                    If (intEndPos <= intStartPos) Then
                        Session("regQueues") = Right(strCurLine, strCurLine.Length - intStartPos)
                    Else
                        Session("regQueues") = Mid(strCurLine, intStartPos, intEndPos - intStartPos)
                    End If
                ElseIf (Left(strCurLine, 3) = "PID") Then
                    intStartPos = InStr(strCurLine, "|")
                    intEndPos = InStr(intStartPos, strCurLine, "|")
                    If (intEndPos <= intStartPos) Then
                        Session("regPID") = Right(strCurLine, strCurLine.Length - intStartPos)
                    Else
                        Session("regPID") = Mid(strCurLine, intStartPos, intEndPos - intStartPos)
                    End If
                ElseIf (Left(strCurLine, 2) = "NF") Then
                    intStartPos = InStr(strCurLine, "|")
                    intEndPos = InStr(intStartPos, strCurLine, "|")
                    If (intEndPos <= intStartPos) Then
                        Session("regNF") = Right(strCurLine, strCurLine.Length - intStartPos)
                    Else
                        Session("regNF") = Mid(strCurLine, intStartPos, intEndPos - intStartPos)
                    End If
                ElseIf (Left(strCurLine, 2) = "mv") Then
                    intStartPos = InStr(strCurLine, "|")
                    intEndPos = InStr(intStartPos, strCurLine, "|")
                    If (intEndPos <= intStartPos) Then
                        Session("regMV") = Right(strCurLine, strCurLine.Length - intStartPos)
                    Else
                        Session("regMV") = Mid(strCurLine, intStartPos, intEndPos - intStartPos)
                    End If
                ElseIf (Left(strCurLine, 2) = "WC") Then
                    intStartPos = InStr(strCurLine, "|")
                    intEndPos = InStr(intStartPos, strCurLine, "|")
                    If (intEndPos <= intStartPos) Then
                        Session("regWC") = Right(strCurLine, strCurLine.Length - intStartPos)
                    Else
                        Session("regWC") = Mid(strCurLine, intStartPos, intEndPos - intStartPos)
                    End If
                ElseIf (Left(strCurLine, 2) = "mr") Then
                    intStartPos = InStr(strCurLine, "|")
                    intEndPos = InStr(intStartPos, strCurLine, "|")
                    If (intEndPos <= intStartPos) Then
                        Session("regMax_Results") = Right(strCurLine, strCurLine.Length - intStartPos)
                    Else
                        Session("regMax_Results") = Mid(strCurLine, intStartPos, intEndPos - intStartPos)
                    End If
                ElseIf (Left(strCurLine, 2) = "db") Then
                    intStartPos = InStr(strCurLine, "|")
                    intEndPos = InStr(intStartPos + 1, strCurLine, "|")
                    Session("db_name") = Trim(Mid(strCurLine, intStartPos + 1, intEndPos - intStartPos - 1))
                    intStartPos = InStr(intEndPos, strCurLine, "|")
                    intEndPos = strCurLine.Length - intStartPos
                    Session("db_pass") = Trim(Right(strCurLine, intEndPos))
                    If (Len(Session("db_pass")) > 0) Then
                        Dim strTemp As String
                        For i As Integer = 1 To Len(Session("db_pass"))
                            strTemp = strTemp & "*"
                        Next
                        Session("db_pass_mask") = strTemp
                    End If
                ElseIf (Left(strCurLine, 2) = "is") Then
                    'Format: <"is"> <store name> <store IP> <store port> <store AET>
                    If (Not intLC2 = 0) Then
                        ReDim Preserve arrStores(6, intLC2 + 1)
                    End If
                    If (Not intLC2 > 8) Then
                        intStartPos = InStr(strCurLine, "|")
                        intEndPos = InStr(intStartPos + 1, strCurLine, "|")
                        arrStores(0, intLC2) = Trim(Mid(strCurLine, intStartPos + 1, intEndPos - intStartPos - 1))
                        intStartPos = InStr(intEndPos, strCurLine, "|")
                        intEndPos = InStr(intStartPos + 1, strCurLine, "|")
                        arrStores(1, intLC2) = Trim(Mid(strCurLine, intStartPos + 1, intEndPos - intStartPos - 1))
                        intStartPos = InStr(intEndPos, strCurLine, "|")
                        intEndPos = InStr(intStartPos + 1, strCurLine, "|")
                        arrStores(2, intLC2) = Trim(Mid(strCurLine, intStartPos + 1, intEndPos - intStartPos - 1))
                        intStartPos = InStr(intEndPos, strCurLine, "|")
                        intEndPos = InStr(intStartPos + 1, strCurLine, "|")
                        arrStores(3, intLC2) = Trim(Mid(strCurLine, intStartPos + 1, intEndPos - intStartPos - 1))
                        intStartPos = InStr(intEndPos, strCurLine, "|")
                        intEndPos = strCurLine.Length - intStartPos
                        arrStores(4, intLC2) = Trim(Right(strCurLine, intEndPos))
                        intLC2 += 1
                    End If
                End If
                intLC += 1
                If (intLC > 10000) Then
                    intDone = 1
                End If
            End While
            objStreamReader.Close()
            intArchives = intLC2

        End If
    End Sub
    Sub PopulateScreen()
        Dim intFilesInDir, intTotalSpaceUsed, intLC As Integer
        Dim strSizeType As String

        MaxQueues.Text = Session("regQueues")
        movedest.Text = Session("regMV")
        If (Session("regPID") = "CCF") Then
            CCF.Checked = True
            Panel1.Style.Value = "display:block"
        Else
            non.Checked = True
            Panel1.Style.Value = "display:none"
        End If
        If (Session("regNF") = "lower") Then
            nflower.Checked = True
        ElseIf (Session("regNF") = "upper") Then
            nfupper.Checked = True
        Else
            nfmixed.Checked = True
        End If
        If (Session("regWC") = "yes") Then
            wcyes.Checked = True
        Else
            wcno.Checked = True
        End If
        MaxResults.Text = Session("regMax_Results")
        DBName.Text = Session("db_name")
        If (Not Trim(Session("db_pass")) Is "") Then
            DBPass.Attributes.Add("value", Session("db_pass_mask"))
        End If
        If (intArchives > 0) Then
            Dim qr As New DataTable()
            qr.Columns.Add("name", Type.GetType("System.String"))
            qr.Columns.Add("ip", Type.GetType("System.String"))
            qr.Columns.Add("port", Type.GetType("System.String"))
            qr.Columns.Add("aet", Type.GetType("System.String"))
            qr.Columns.Add("default", Type.GetType("System.String"))
            For i As Integer = 0 To intArchives - 1
                qr.Rows.Add()
                qr.Rows(qr.Rows.Count - 1)("name") = arrStores(0, i)
                qr.Rows(qr.Rows.Count - 1)("ip") = arrStores(1, i)
                qr.Rows(qr.Rows.Count - 1)("port") = arrStores(2, i)
                qr.Rows(qr.Rows.Count - 1)("aet") = arrStores(3, i)
                qr.Rows(qr.Rows.Count - 1)("default") = arrStores(4, i)
            Next
            ImageServers.DataSource = qr
            ImageServers.DataBind()
        End If

        Dim di As New IO.DirectoryInfo("c:\inetpub\wwwroot\Workplace_DICOM_QR_tool\logs")
        Dim diar1 As IO.FileInfo() = di.GetFiles()
        Dim dra As IO.FileInfo

        intFilesInDir = 0
        intTotalSpaceUsed = 0
        strSizeType = "bytes"
        For Each dra In diar1
            intFilesInDir = intFilesInDir + 1
            intTotalSpaceUsed = intTotalSpaceUsed + dra.Length
        Next
        If (intTotalSpaceUsed > 1000000000000) Then
            intTotalSpaceUsed = intTotalSpaceUsed / 1000000000000
            strSizeType = "TB"
        ElseIf (intTotalSpaceUsed > 1000000000) Then
            intTotalSpaceUsed = intTotalSpaceUsed / 1000000000
            strSizeType = "GB"
        ElseIf (intTotalSpaceUsed > 1000000) Then
            intTotalSpaceUsed = intTotalSpaceUsed / 1000000
            strSizeType = "MB"
        ElseIf (intTotalSpaceUsed > 1000) Then
            intTotalSpaceUsed = intTotalSpaceUsed / 1000
            strSizeType = "Kbytes"
        End If

        Logs.Text = "<center><b>" & intFilesInDir & "</b> log files <br />using <b>" & intTotalSpaceUsed & "</b> " & strSizeType & ".</center><br />"

        Dim p As Process
        For Each p In Process.GetProcesses
            If (InStr(p.ProcessName, "movescu") > 0) Then
                intLC += 1
            End If
        Next

        Moves.Text = "<center><b>" & intLC & "</b> moves running.</center><br />"

    End Sub

    Sub submit(ByVal sender As Object, ByVal e As EventArgs)
        ReadRegistry()
        Dim strConfigFile As String
        Dim objStreamWriter As FileStream

        strConfigFile = "\inetpub\wwwroot\Workplace_DICOM_QR_tool\config\config.txt"
        File.Delete(strConfigFile)
        objStreamWriter = File.OpenWrite(strConfigFile)
        Dim strCurLine As Byte() = New UTF8Encoding(True).GetBytes("mq|" & MaxQueues.Text & vbCrLf)

        objStreamWriter.Write(strCurLine, 0, strCurLine.Length)
        strCurLine = New UTF8Encoding(True).GetBytes("mr|" & MaxResults.Text & vbCrLf)
        objStreamWriter.Write(strCurLine, 0, strCurLine.Length)

        If (Not Trim(movedest.Text) = "") Then
            strCurLine = New UTF8Encoding(True).GetBytes("mv|" & movedest.Text & vbCrLf)
            objStreamWriter.Write(strCurLine, 0, strCurLine.Length)
        End If

        If (non.Checked = True) Then
            strCurLine = New UTF8Encoding(True).GetBytes("PID|non" & vbCrLf)
        Else
            strCurLine = New UTF8Encoding(True).GetBytes("PID|CCF" & vbCrLf)
        End If
        objStreamWriter.Write(strCurLine, 0, strCurLine.Length)

        If (nflower.Checked = True) Then
            strCurLine = New UTF8Encoding(True).GetBytes("NF|lower" & vbCrLf)
        ElseIf (nfmixed.Checked = True) Then
            strCurLine = New UTF8Encoding(True).GetBytes("NF|mixed" & vbCrLf)
        Else
            strCurLine = New UTF8Encoding(True).GetBytes("NF|upper" & vbCrLf)
        End If
        objStreamWriter.Write(strCurLine, 0, strCurLine.Length)

        If (wcyes.Checked = True) Then
            strCurLine = New UTF8Encoding(True).GetBytes("WC|yes" & vbCrLf)
        Else
            strCurLine = New UTF8Encoding(True).GetBytes("WC|no" & vbCrLf)
        End If
        objStreamWriter.Write(strCurLine, 0, strCurLine.Length)

        If (DBPass.Text = Session("db_pass_mask")) Then
            strCurLine = New UTF8Encoding(True).GetBytes("db|" & DBName.Text & "|" & Session("db_pass") & vbCrLf)
        Else
            strCurLine = New UTF8Encoding(True).GetBytes("db|" & DBName.Text & "|" & DBPass.Text & vbCrLf)
        End If
        objStreamWriter.Write(strCurLine, 0, strCurLine.Length)
        For i As Integer = 0 To UBound(arrStores, 2) - 1
            If (Not Trim(arrStores(0, i)) = "") Then
                strCurLine = New UTF8Encoding(True).GetBytes("is|" & arrStores(0, i) & "|" & arrStores(1, i) & "|" & arrStores(2, i) & "|" & arrStores(3, i) & "|" & arrStores(4, i) & vbCrLf)
                objStreamWriter.Write(strCurLine, 0, strCurLine.Length)
            End If
        Next
        objStreamWriter.Close()
        ReadRegistry()
        PopulateScreen()
    End Sub
    Sub AddImage(ByVal sender As Object, ByVal e As EventArgs)
        Dim fhConfig As FileInfo = New FileInfo("\inetpub\wwwroot\Workplace_DICOM_QR_tool\config\config.txt")
        Dim objSW As StreamWriter

        objSW = fhConfig.AppendText()
        objSW.WriteLine("is|" & Name.Text & "|" & ip.Text & "|" & port.Text & "|" & aet.Text & "|" & "no" & vbCrLf)
        objSW.Close()
        ReadRegistry()
        PopulateScreen()
    End Sub
    Sub PurgeLogsSub(ByVal sender As Object, ByVal e As EventArgs)
        If (Directory.Exists("c:\inetpub\wwwroot\Workplace_DICOM_QR_tool\logs")) Then
            For Each fName As String In Directory.GetFiles("c:\inetpub\wwwroot\Workplace_DICOM_QR_tool\logs")
                If File.Exists(fName) Then
                    Try
                        File.Delete(fName)
                    Catch
                    End Try
                End If
            Next
        End If
        ReadRegistry()
        PopulateScreen()
    End Sub
    Sub ClearQueueSub(ByVal sender As Object, ByVal e As EventArgs)
        Dim p As Process
        For Each p In Process.GetProcesses
            If (InStr(p.ProcessName, "movescu") > 0) Then
                p.Kill()
            End If
        Next
        ReadRegistry()
        PopulateScreen()
    End Sub

    Sub IS_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
        ReadRegistry()
        Dim row As GridViewRow = ImageServers.SelectedRow
        Dim strConfigFile As String
        Dim objStreamWriter As FileStream

        strConfigFile = "\inetpub\wwwroot\Workplace_DICOM_QR_tool\config\config.txt"
        File.Delete(strConfigFile)
        objStreamWriter = File.OpenWrite(strConfigFile)
        Dim strCurLine As Byte() = New UTF8Encoding(True).GetBytes("mq|" & MaxQueues.Text & vbCrLf)

        If (Not Trim(MaxQueues.Text) = "") Then
            objStreamWriter.Write(strCurLine, 0, strCurLine.Length)
        End If

        If (Not Trim(MaxResults.Text) = "") Then
            strCurLine = New UTF8Encoding(True).GetBytes("mr|" & MaxResults.Text & vbCrLf)
            objStreamWriter.Write(strCurLine, 0, strCurLine.Length)
        End If

        If (Not Trim(movedest.Text) = "") Then
            strCurLine = New UTF8Encoding(True).GetBytes("mv|" & movedest.Text & vbCrLf)
            objStreamWriter.Write(strCurLine, 0, strCurLine.Length)
        End If

        If (non.Checked = True) Then
            strCurLine = New UTF8Encoding(True).GetBytes("PID|non" & vbCrLf)
        Else
            strCurLine = New UTF8Encoding(True).GetBytes("PID|CCF" & vbCrLf)
        End If
        objStreamWriter.Write(strCurLine, 0, strCurLine.Length)

        If (Not Trim(DBName.Text) = "") Then
            If (DBPass.Text = Session("db_pass_mask")) Then
                strCurLine = New UTF8Encoding(True).GetBytes("db|" & DBName.Text & "|" & Session("db_pass") & vbCrLf)
            Else
                strCurLine = New UTF8Encoding(True).GetBytes("db|" & DBName.Text & "|" & DBPass.Text & vbCrLf)
            End If
            objStreamWriter.Write(strCurLine, 0, strCurLine.Length)
        End If

        For i As Integer = 0 To UBound(arrStores, 2) - 1
            If (Not arrStores(0, i) = row.Cells(1).Text) Then
                strCurLine = New UTF8Encoding(True).GetBytes("is|" & arrStores(0, i) & "|" & arrStores(1, i) & "|" & arrStores(2, i) & "|" & arrStores(3, i) & "|no" & vbCrLf)
                objStreamWriter.Write(strCurLine, 0, strCurLine.Length)
            Else
                If (row.Cells(5).Text = "yes") Then
                    strCurLine = New UTF8Encoding(True).GetBytes("is|" & arrStores(0, i) & "|" & arrStores(1, i) & "|" & arrStores(2, i) & "|" & arrStores(3, i) & "|no" & vbCrLf)
                    objStreamWriter.Write(strCurLine, 0, strCurLine.Length)
                Else
                    strCurLine = New UTF8Encoding(True).GetBytes("is|" & arrStores(0, i) & "|" & arrStores(1, i) & "|" & arrStores(2, i) & "|" & arrStores(3, i) & "|yes" & vbCrLf)
                    objStreamWriter.Write(strCurLine, 0, strCurLine.Length)
                End If
            End If
        Next
        objStreamWriter.Close()
        Response.Redirect("admin.aspx")
    End Sub
    Public Sub ImageServers_RowDeleting(ByVal sender As [Object], ByVal e As GridViewDeleteEventArgs)
        ReadRegistry()
        Dim strConfigFile As String
        Dim objStreamWriter As FileStream

        strConfigFile = "\inetpub\wwwroot\Workplace_DICOM_QR_tool\config\config.txt"
        File.Delete(strConfigFile)
        objStreamWriter = File.OpenWrite(strConfigFile)
        Dim strCurLine As Byte() = New UTF8Encoding(True).GetBytes("mq|" & MaxQueues.Text & vbCrLf)

        If (Not Trim(MaxQueues.Text) = "") Then
            objStreamWriter.Write(strCurLine, 0, strCurLine.Length)
        End If

        If (Not Trim(MaxResults.Text) = "") Then
            strCurLine = New UTF8Encoding(True).GetBytes("mr|" & MaxResults.Text & vbCrLf)
            objStreamWriter.Write(strCurLine, 0, strCurLine.Length)
        End If

        If (Not Trim(movedest.Text) = "") Then
            strCurLine = New UTF8Encoding(True).GetBytes("mv|" & movedest.Text & vbCrLf)
            objStreamWriter.Write(strCurLine, 0, strCurLine.Length)
        End If

        If (non.Checked = True) Then
            strCurLine = New UTF8Encoding(True).GetBytes("PID|non" & vbCrLf)
        Else
            strCurLine = New UTF8Encoding(True).GetBytes("PID|CCF" & vbCrLf)
        End If
        objStreamWriter.Write(strCurLine, 0, strCurLine.Length)

        If (nflower.Checked = True) Then
            strCurLine = New UTF8Encoding(True).GetBytes("NF|lower" & vbCrLf)
        ElseIf (nfmixed.Checked = True) Then
            strCurLine = New UTF8Encoding(True).GetBytes("NF|mixed" & vbCrLf)
        Else
            strCurLine = New UTF8Encoding(True).GetBytes("NF|upper" & vbCrLf)
        End If
        objStreamWriter.Write(strCurLine, 0, strCurLine.Length)

        If (wcyes.Checked = True) Then
            strCurLine = New UTF8Encoding(True).GetBytes("WC|yes" & vbCrLf)
        Else
            strCurLine = New UTF8Encoding(True).GetBytes("WC|no" & vbCrLf)
        End If
        objStreamWriter.Write(strCurLine, 0, strCurLine.Length)

        If (Not Trim(DBName.Text) = "") Then
            If (DBPass.Text = Session("db_pass_mask")) Then
                strCurLine = New UTF8Encoding(True).GetBytes("db|" & DBName.Text & "|" & Session("db_pass") & vbCrLf)
            Else
                strCurLine = New UTF8Encoding(True).GetBytes("db|" & DBName.Text & "|" & DBPass.Text & vbCrLf)
            End If
            objStreamWriter.Write(strCurLine, 0, strCurLine.Length)
        End If

        For i As Integer = 0 To UBound(arrStores, 2) - 1
            If (Not i = e.RowIndex) Then
                strCurLine = New UTF8Encoding(True).GetBytes("is|" & arrStores(0, i) & "|" & arrStores(1, i) & "|" & arrStores(2, i) & "|" & arrStores(3, i) & "|" & arrStores(4, i) & vbCrLf)
                objStreamWriter.Write(strCurLine, 0, strCurLine.Length)
            End If
        Next
        objStreamWriter.Close()
        Response.Redirect("admin.aspx")
    End Sub

    Protected Sub Page_LoadComplete(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LoadComplete
        If (Not IsPostBack) Then
            ReadRegistry()
            PopulateScreen()
        End If
    End Sub
    Protected Sub page_load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Page.Response.Cache.SetCacheability(HttpCacheability.NoCache)
    End Sub
    Protected Sub make_row_link(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.GridViewRowEventArgs)
        If (e.Row.RowType = DataControlRowType.DataRow) Then
            Dim row As GridViewRow = ImageServers.SelectedRow
            e.Row.Attributes.Add("onmouseover", "this.style.cursor='hand';this.style.textDecoration='underline';")
            e.Row.Attributes.Add("onmouseout", "this.style.textDecoration='none';")
            e.Row.Attributes.Add("ondblclick", ClientScript.GetPostBackClientHyperlink(Me.ImageServers, "Select$" + e.Row.RowIndex.ToString()))
            'e.Row.Attributes.Add("onClick", "window.open('default.aspx?rs=" & e.Row.RowIndex & "');")
        End If
    End Sub

End Class
